
ALTER TABLE `articles` ADD `money` decimal(11,2) DEFAULT '0.00';

DROP TABLE IF EXISTS `articles_pay_content`;
CREATE TABLE `articles_pay_content` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`auto_id`),
  KEY `id` (`id`),
  KEY `auto_id` (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `pay_order_article_relation`;
CREATE TABLE `pay_order_article_relation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
	`uid` char(32) DEFAULT NULL,
  `order_id` char(32) DEFAULT NULL,
  `goods_id` char(32) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `buy_num` int(11) DEFAULT NULL,
  `pay_status` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `uid` (`uid`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `pay_log`;
CREATE TABLE `pay_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `order_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  `sub_type` varchar(255) DEFAULT NULL,
  `item_name` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL COMMENT '总价',
  `add_time` int(11) DEFAULT NULL,
  `pay_type` varchar(255) DEFAULT NULL,
  `pay_money` decimal(11,2) DEFAULT '0.00' COMMENT '支付金额',
  `pay_time` int(11) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  `action` varchar(255) DEFAULT NULL,
  `receivables_uid` char(32) DEFAULT NULL,
  `receivables_money` decimal(11,2) DEFAULT '0.00',
  `transaction_type` varchar(255) DEFAULT NULL,
  `yue_before` decimal(11,2) DEFAULT NULL,
  `yue_after` decimal(11,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `item_type` (`item_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `pay_order`;
CREATE TABLE `pay_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` char(32) DEFAULT NULL,
  `uid` char(32) DEFAULT NULL,
  `mod_id` char(32) DEFAULT NULL,
  `item_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  `sub_type` varchar(255) DEFAULT NULL,
  `item_name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL COMMENT '总价',
  `buy_num` int(11) DEFAULT NULL COMMENT '购买数量',
  `buy_money` decimal(11,2) DEFAULT NULL COMMENT '购买单价',
  `add_time` int(11) DEFAULT NULL,
  `pay_status` int(255) NOT NULL DEFAULT '0',
  `pay_type` varchar(255) DEFAULT NULL,
  `pay_money` decimal(11,2) DEFAULT '0.00' COMMENT '支付金额',
  `pay_time` int(11) DEFAULT NULL,
  `delivery_status` int(1) NOT NULL DEFAULT '0' COMMENT '发货状态',
  `delivery_time` int(11) DEFAULT NULL COMMENT '发货时间',
  `receiving_status` int(1) NOT NULL DEFAULT '0' COMMENT '收获状态',
  `receiving_time` int(11) DEFAULT NULL COMMENT '确认收货时间',
  `buyer_evaluation_status` int(1) NOT NULL DEFAULT '0' COMMENT '买家评价状态',
  `buyer_evaluation_time` int(11) DEFAULT NULL,
  `seller_evaluation_status` int(1) NOT NULL DEFAULT '0' COMMENT '卖家评价状态',
  `seller_evaluation_time` int(11) DEFAULT NULL,
  `is_close` int(1) NOT NULL DEFAULT '0',
  `is_close_time` int(11) DEFAULT NULL,
  `is_close_uid` char(32) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`),
  KEY `mod_id` (`mod_id`),
  KEY `item_type` (`item_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `articles` ADD `daily_push_num` int(11) DEFAULT '0';
ALTER TABLE `tags` ADD `daily_push_num` int(11) DEFAULT '0';
INSERT INTO `base_settings` VALUES 	(47,'baiduDailyApi', '');
INSERT INTO `base_settings` VALUES 	(48,'baiduDailyApiStatus', '');


UPDATE `base_settings` SET `val` = '109' WHERE `key` = 'localCurrentVersionNum';
UPDATE `base_settings` SET `val` = 'v1.0.9' WHERE `key` = 'localCurrentVersion';

