<?php
namespace app\article\controller;
use app\common\controller\AdminBase;

class ApiAdminArticleCategory extends AdminBase
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->itemType = 'article';
        $this->itemName = '内容';
        $this->item = 'Articles';
        $this->itemCategory = 'ArticlesCategory';
        $this->itemContent = 'ArticlesContent';
        $this->itemSearch = 'ArticlesSearch';
        $this->itemSearchRel = 'ArticlesSearchRel';
        $this->itemModelNameSpace = 'app\article\model\Articles';
        $this->itemCategoryModelNameSpace = 'app\article\model\ArticlesCategory';
    }
    
    public function categoryAdd()
    {
        $data = $this->request->post();
        if (!$data['title']) {
            return jsonError('请输入名称');
        }
        if (!$data['url_name']) {
          return jsonError('请输入URL别名');
        }
        $itemCategoryInfo = db($this->itemCategory)->where('pid',$data['pid'])->where('title',$data['title'])->find();
        if ($itemCategoryInfo) {
            return jsonError('添加项已存在');
        }
        $itemInfo = db($this->itemCategory)->where('pid',$data['pid'])->where('url_name',$data['url_name'])->find();
        if ($itemInfo) {
            return jsonError('别名已存在，请重新输入');
        }
        $res = model($this->itemCategoryModelNameSpace)->categoryAdd($data);
        if ($res) {
            return jsonSuccess('操作成功');
        } else {
            return jsonError('操作失败');
        }
    }
    
    public function categoryEdit() {
        $data = $this->request->post();
        $itemInfo = db($this->itemCategory)->where('id',$data['id'])->find();
        if (!$itemInfo) {
            return jsonError('操作项不存在');
        }
        if (!$data['title']) {
            return jsonError('请输入名称');
        }
        if (!$data['url_name']) {
          return jsonError('请输入URL别名');
        }
        $itemCategoryInfo = db($this->itemCategory)->where('pid',$data['pid'])->where('id','<>',$data['id'])->where('title',$data['title'])->find();
        if ($itemCategoryInfo) {
            return jsonError('名称已存在');
        }
        $itemInfo = db($this->itemCategory)->where('pid',$data['pid'])->where('id','<>',$data['id'])->where('url_name',$data['url_name'])->find();
        if ($itemInfo) {
            return jsonError('别名已存在，请重新输入');
        }
        $res = model($this->itemCategoryModelNameSpace)->categoryEdit($data);
        if ($res) {
            return jsonSuccess('操作成功');
        } else {
            return jsonError('操作失败');
        }
    }
    
    public function categoryContentEdit()
    {
        $id = input('post.id');
        $content = input('post.content');
        db($this->itemCategory)->where('id',$id)->update(array(
            'content' => htmlspecialchars($content),
        ));
        return jsonSuccess('操作成功');
    }
    
    public function categoryDel()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        if ($categoryInfo = db($this->itemCategory)->where('id',$id)->find()) {
            $itemInfo = db($this->item)->where('cid',$categoryInfo['id'])->find();
            if ($itemInfo) {
                return jsonError('删除的项中含有已发布的内容，系统无法删除');
            }
            db($this->itemCategory)->where('id',$id)->delete();
            return jsonSuccess('删除成功');
        } else {
            return  jsonError('不存在');
        }

    }
    
    public function categoryListByArticlePublish()
    {
    	$data = $this->request->post();
        $data['orderBy'] = $data['orderBy'] ? $data['orderBy'] : 'sort';
        $data['pid'] = 0;
        $data['isAll'] = 1;
        $categoryList = db("ArticlesCategory")->where('pid',0)->order('sort ASC')->select();
        if ($categoryList) {
        	$modelList = db('ArticlesModel')->select();
            foreach ($categoryList as $key => $value) {
            	$data['pid'] = $value['id'];
		        $categoryList[$key]['value'] = $value['id'];
		        $categoryList[$key]['label'] = $value['title'];
                $categoryList[$key]['children'] = db("ArticlesCategory")->where('pid',$data['pid'])->order('sort ASC')->select();
                if ($categoryList[$key]['children']) {
	            	foreach ($categoryList[$key]['children'] as $k => $v) {
				        $categoryList[$key]['children'][$k]['value'] = $v['id'];
				        $categoryList[$key]['children'][$k]['label'] = $v['title'];
	            		if ($modelList) {
			                foreach ($modelList as $kk => $vv) {
			                	if ($vv['name'] == $v['model_name']) {
			                		$categoryList[$key]['children'][$k]['modelInfo'] = $vv;
			                	}
			                }
	            		}
//              		$categoryList[$key]['children'][$k]['modelInfo'] = db('ArticlesModel')->where('name',$v['model_name'])->find();
	                }
                }
                if ($modelList) {
	                foreach ($modelList as $kk => $vv) {
	                	if ($vv['name'] == $value['model_name']) {
	                		$categoryList[$key]['modelInfo'] = $vv;
	                	}
	                }
                }
//              $categoryList[$key]['modelInfo'] = db('ArticlesModel')->where('name',$value['model_name'])->find();
            }
        }
        return jsonSuccess('操作成功',['categoryList' => $categoryList]);
    }
    
    public function categoryList()
    {
        $data = $this->request->post();
        $data['orderBy'] = $data['orderBy'] ? $data['orderBy'] : 'sort';
        $data['pid'] = 0;
        $data['isAll'] = 1;
        $categoryList = model('app\\article\\model\\ArticlesCategoryByAdmin')->getCategory($data);
        if ($categoryList) {
        	$modelList = db('ArticlesModel')->select();
            foreach ($categoryList as $key => $value) {
            	$data['pid'] = $value['id'];
                $categoryList[$key]['children'] = model('app\\article\\model\\ArticlesCategoryByAdmin')->getCategory($data);
                if ($categoryList[$key]['children']) {
	            	foreach ($categoryList[$key]['children'] as $k => $v) {
	            		if ($modelList) {
			                foreach ($modelList as $kk => $vv) {
			                	if ($vv['name'] == $v['model_name']) {
			                		$categoryList[$key]['children'][$k]['modelInfo'] = $vv;
			                	}
			                }
	            		}
//              		$categoryList[$key]['children'][$k]['modelInfo'] = db('ArticlesModel')->where('name',$v['model_name'])->find();
	                }
                }
                if ($modelList) {
	                foreach ($modelList as $kk => $vv) {
	                	if ($vv['name'] == $value['model_name']) {
	                		$categoryList[$key]['modelInfo'] = $vv;
	                	}
	                }
                }
//              $categoryList[$key]['modelInfo'] = db('ArticlesModel')->where('name',$value['model_name'])->find();
            }
        }
        return jsonSuccess('操作成功',['categoryList' => $categoryList]);
    }

    public function categoryInfo()
    {
        $data = $this->request->post();
        $itemInfo = model($this->itemCategoryModelNameSpace)->getCategoryInfo($data['cid']);
        return jsonSuccess('操作成功',['itemInfo' => $itemInfo]);
    }
    public function categorySortSave()
    {
        $itemList = input('post.itemList/a');
        if ($itemList) {
            foreach ($itemList as $key => $val) {
                if ($itemListInfo = db($this->itemCategory)->where('id',$val['id'])->find()) {
                    db($this->itemCategory)->where('id',$val['id'])->update(array('sort' => $val['sort']));
                }
                if ($itemList[$key]['children']) {
                    foreach ($itemList[$key]['children'] as $k => $v) {
                        if (db($this->itemCategory)->where('id',$v['id'])->find()) {
                            db($this->itemCategory)->where('id',$v['id'])->update(array('sort' => $v['sort']));
                        }
                    }
                }
            }
            return jsonSuccess('保存成功');
        }
        
    }

    public function getTemplate()
    {
        $modelName = input('post.modelName');
        $pages = [];
        $template = config('template.view_path') . DS . $modelName . DS;
        if (is_dir($template)) {
            $templateFile = opendir($template);
            if ($templateFile) {
                while (false !== ($file = readdir($templateFile))) {
                    if (substr($file, 0, 1) != '.' AND is_file($template . DS . $file)) {
                        $pages[] = $file;
                    }
                }
                closedir($templateFile);
            }
        }
        sort($pages);
        return jsonSuccess('',$pages);
    }
    
    public function switchStatus()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        if ($categoryInfo = db($this->itemCategory)->where('id',$id)->find()) {
            if ($categoryInfo['status'] == 1) {
                db($this->itemCategory)->where('id',$id)->update(array(
                    'status' => 0,
                ));
            } else {
                db($this->itemCategory)->where('id',$id)->update(array(
                    'status' => 1,
                ));
            }
            return jsonSuccess('删除成功');
        } else {
            return  jsonError('操作失败');
        }
    }
    
}