<?php
namespace app\article\controller;

use app\common\lib\Htmlp;
use app\common\controller\AdminBase;
class ApiAdminArticleCommentsVerify extends AdminBase
{
	protected $beforeActionList = ['start'];
    public function start() {
        $this->itemType = 'article';
        $this->itemName = '内容';
        $this->item = 'Articles';
        $this->itemCategory = 'ArticlesCategory';
        $this->itemContent = 'ArticlesContent';
        $this->itemSearch = 'ArticlesSearch';
        $this->itemSearchRel = 'ArticlesSearchRel';
        $this->itemModelNameSpace = 'app\article\model\Articles';
        $this->itemCategoryModelNameSpace = 'app\article\model\ArticlesCategory';
        $this->itemTagsRelModelNameSpace = 'app\tag\model\TagsRel';
        $this->domain = config('domain');
        $this->settingInfo = config('settingInfo');
        $this->itemSettingInfo = config('articleSettingInfo');
    }
    
    public function itemVerify()
    {
        $id = input('post.id');
        $status = input('post.status');
        if (!$id) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('ArticlesCommentsVerify')->where('id',$id)->find();
        if (!$itemInfo) {
            return jsonError('操作项不存在');
        }
        if ($status == 1) {
        	if ($itemInfo['pid'] == 0) {
	    		db('ArticlesComments')->insert(array(
		            'id' => $itemInfo['id'],
		            'item_id' => $itemInfo['item_id'],
		            'uid' => $itemInfo['uid'],
		            'content' => $itemInfo['content'],
		            'create_time' => $itemInfo['create_time'],
		        ));
		        $itemCount = db('ArticlesComments')->where('item_id',$itemInfo['item_id'])->count();
		        db('Articles')->where('uuid',$itemInfo['item_id'])->update(array('comments_num' => $itemCount));
		        //更新
		        db('Users')->where('uid',$itemInfo['uid'])->update([
		            'article_comments_num' => db('ArticlesComments')->where('uid',$itemInfo['uid'])->count(),
		        ]);
		        db('ArticlesCommentsVerify')->where('id',$id)->delete();
        	}
        	if ($itemInfo['pid'] == 1) {
        		db('ArticlesCommentsComments')->insert(array(
		            'id' => $itemInfo['uuid'],
		            'item_id' => $itemInfo['item_id'],
		            'uid' => $itemInfo['uid'],
		            'content' => $itemInfo['content'],
		            'create_time' => $itemInfo['create_time'],
	                'is_reply' =>$itemInfo['is_reply'],
	                'reply_uid' => $itemInfo['reply_uid'],
	                'reply_item_id' => $itemInfo['reply_item_id'],
		        ));
		        db('ArticlesCommentsVerify')->where('id',$id)->delete();
        	}
        }
        if ($status == 2) {
	        db('ArticlesCommentsVerify')->where('id',$id)->update(array('status' => 2));
        }
     	return jsonSuccess('操作成功');
    }
    
    public function itemList()
    {
        $param['page'] = input('post.page');
        $param['limit'] = input('post.limit');
        $param['orderBy'] = input('post.orderBy');
        $param['order'] = input('post.order');
        $itemList = model('app\article\model\ArticlesCommentsVerify')->getItemList($param);
        if ($itemList) {
        	
        }
        $total = model('app\article\model\ArticlesCommentsVerify')->getCount($param);
        if (!$itemList) {
            $itemList = [];
        }
        return jsonSuccess('ok',['itemList' => $itemList,'total' => $total,'page' => $param['page']]);
    }
    
    public function itemDel()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('ArticlesCommentsVerify')->where('id',$id)->find();
        if (!$itemInfo) {
            return jsonError('删除项不存在');
        }
    	db('ArticlesCommentsVerify')->where('id',$id)->delete();
     	return jsonSuccess('操作成功');
    }
    
    public function itemsDel()
    {
        $ids = input('post.ids');
        if (!$ids) {
          return jsonError('缺少参数');
        }
        $ids = explode(',',$ids);
        foreach ($ids as $id) {
	        db('ArticlesCommentsVerify')->where('id',$id)->delete();
        }
        return jsonSuccess('操作成功');
    }
    
}