<?php
namespace app\article\controller;
use think\Request;
use app\common\controller\AdminBase;

class ApiAdminArticleVerify extends AdminBase
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->itemType = 'article';
        $this->itemName = '内容';
        $this->item = 'Articles';
        $this->itemCategory = 'ArticlesCategory';
        $this->itemContent = 'ArticlesContent';
        $this->itemSearch = 'ArticlesSearch';
        $this->itemSearchRel = 'ArticlesSearchRel';
        $this->itemModelNameSpace = 'app\article\model\Articles';
        $this->itemCategoryModelNameSpace = 'app\article\model\ArticlesCategory';
    }
    
    public function itemVerify()
    {
        $uuid = input('post.uuid');
        $status = input('post.status');
        if (!$uuid) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('ArticlesVerify')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('操作项不存在');
        }
        if ($status == 1) {
        	$data = [
	        	'uuid' => $itemInfo['uuid'],
	            'cid' => $itemInfo['cid'],
	            'uid' => $itemInfo['uid'],
	            'title' =>  $itemInfo['title'],
	            'img_url' => $itemInfo['img_url'],
	            'description' => $itemInfo['description'],
	            'tags' => $itemInfo['tags'],
	            'keywords' => $itemInfo['keywords'],
	            'content' => htmlspecialchars_decode($itemInfo['content']),
        	];
        	if (!$itemInfo['type']) {
	        	$itemInfo = db('Articles')->where('title',$itemInfo['title'])->find();
	        	if ($itemInfo) {
	            	return jsonError('标题已存在');
	        	}
    			$res = model('app\article\model\Articles')->itemAdd($data);
	        	if ($res) {
		        	db('ArticlesVerify')->where('uuid',$uuid)->delete();
	    		} else {
     				return jsonError('操作失败');
    			}
        	}
        	if ($itemInfo['type'] == 'edit') {
	        	$itemInfo = db('Articles')->where('uuid',$data['uuid'])->find();
	        	if (!$itemInfo) {
	            	return jsonError('文章不存在');
	        	}
    			$res = model('app\article\model\Articles')->itemEdit($data);
	        	if ($res) {
		        	db('ArticlesVerify')->where('uuid',$uuid)->delete();
	    		} else {
     				return jsonError('操作失败');
    			}
        	}
   		}
        if ($status == 2) {
	        db('ArticlesVerify')->where('uuid',$uuid)->update(array('status' => 2));
        }
     	return jsonSuccess('操作成功');
    }
    
    public function itemList()
    {
        $page = input('post.page');
        $limit = input('post.limit');
        $orderBy = input('post.orderBy');
        $order = input('post.order');
        
        $page = $page ? $page : 1;
        $limit = $limit ? $limit : 10;
        $orderBy = $orderBy ? $orderBy : 'create_time';
        $order = $order ? $order : 'desc';
        
     	$itemList = db('ArticlesVerify')->page($page,$limit)->order($orderBy,$order)->select();
     	if ($itemList) {
     		foreach ($itemList as $key => $val) {
     			$itemList[$key]['userInfo'] = model('app\user\model\Users')->getItemInfo($val['uid']);
     		}
     	}
     	$itemCount = db('ArticlesVerify')->count();
	    return jsonSuccess('',['itemList' => $itemList,'total' => $itemCount,'page' => $page]);
    }

    public function itemDel()
    {
        $uuid = input('post.uuid');
        if (!$uuid) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('ArticlesVerify')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('删除项不存在');
        }
    	db('ArticlesVerify')->where('uuid',$uuid)->delete();
     	return jsonSuccess('操作成功');
    }
    
    public function itemsDel()
    {
        $uuids = input('post.uuids');
        if (!$uuids) {
          return jsonError('缺少参数');
        }
        $uuids = explode(',',$uuids);
        foreach ($uuids as $uuid) {
	        db('ArticlesVerify')->where('uuid',$uuid)->delete();
        }
        return jsonSuccess('操作成功');
    }
    
}