<?php
namespace app\article\controller;
use think\Request;
use app\common\lib\Htmlp;
use app\common\controller\UserBase;

class ApiUserArticleAction extends UserBase
{
	/**
	 * 加精
	 * 
     */
    public function itemElite()
    {
        $uuid = input('post.uuid');
        $status = input('post.status');
        if (!$uuid) {
            return jsonError('缺少ID');
        }
        $itemInfo = db('Articles')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('内容不存在');
        }
        //权限验证
        $userGroupExtendInfo = model('app\\article\\model\\Articles')->getUserGroupExtendData($itemInfo['cid']);
        if (!$userGroupExtendInfo['articleElite']) {
        	return jsonError('你当前所在的分组无此权限');
        }
    	db('Articles')->where('uuid',$uuid)->update(array('elite' => $status ? 1 : 0));
        //日志更新
        $info = $itemInfo['title'];
     	model('app\common\model\Log')->itemAdd($info,config('userId'),'articleElit');
        return jsonSuccess('操作成功');
    }
    
	/**
	 * 置顶
	 * 
     */
    public function itemTop()
    {
        $uuid = input('post.uuid');
        $status = input('post.status');
        if (!$uuid) {
            return jsonError('缺少ID');
        }
        $itemInfo = db('Articles')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('内容不存在');
        }
        //权限验证
        $userGroupExtendInfo = model('app\\article\\model\\Articles')->getUserGroupExtendData($itemInfo['cid']);
        if (!$userGroupExtendInfo['articleTop']) {
        	return jsonError('你当前所在的分组无此权限');
        }
    	db('Articles')->where('uuid',$uuid)->update(array('top' => $status ? 1 : 0));
        //日志更新
        $info = $itemInfo['title'];
     	model('app\common\model\Log')->itemAdd($info,config('userId'),'articleTop');
        return jsonSuccess('操作成功');
    }
	/**
	 * 推荐
	 * 
     */
    public function itemRecommend()
    {
        $uuid = input('post.uuid');
        $status = input('post.status');
        if (!$uuid) {
            return jsonError('缺少ID');
        }
        $itemInfo = db('Articles')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('内容不存在');
        }
        //权限验证
        $userGroupExtendInfo = model('app\\article\\model\\Articles')->getUserGroupExtendData($itemInfo['cid']);
        if (!$userGroupExtendInfo['articleRecommend']) {
        	return jsonError('你当前所在的分组无此权限');
        }
    	db('Articles')->where('uuid',$uuid)->update(array('is_recommend' => $status ? 1 : 0));
        //日志更新
        $info = $itemInfo['title'];
     	model('app\common\model\Log')->itemAdd($info,config('userId'),'articleRecommend');
        return jsonSuccess('操作成功');
    }
    
	/**
	 * 帖子删除
	 * 
	 */
    public function itemDel()
    {
        $uuid = input('post.uuid');
        if (!$uuid) {
            return jsonError('缺少ID');
        }
        $itemInfo = db('Articles')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('内容不存在');
        }
        //权限验证
        $userGroupExtendInfo = model('app\\article\\model\\Articles')->getUserGroupExtendData($itemInfo['cid']);
        if (!$userGroupExtendInfo['articleDel']) {
        	return jsonError('你当前所在的分组无此权限');
        }
    	db('Articles')->where('uuid',$uuid)->delete();
        //日志更新
        $info = $itemInfo['title'];
     	model('app\common\model\Log')->itemAdd($info,config('userId'),'articleDel');
        return jsonSuccess('操作成功');
    }
	
}