<?php
namespace app\article\controller;
use think\Request;
use app\common\lib\Htmlp;
use app\common\controller\UserBase;

class ApiUserArticleVerify extends UserBase
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->itemType = 'article';
        $this->itemName = '内容';
        $this->item = 'Articles';
        $this->itemCategory = 'ArticlesCategory';
        $this->itemContent = 'ArticlesContent';
        $this->itemSearch = 'ArticlesSearch';
        $this->itemSearchRel = 'ArticlesSearchRel';
        $this->itemModelNameSpace = 'app\article\model\Articles';
        $this->itemCategoryModelNameSpace = 'app\article\model\ArticlesCategory';
    }
    
    public function itemList()
    {
        $page = input('post.page');
        $limit = input('post.limit');
        $orderBy = input('post.orderBy');
        $order = input('post.order');
        
        $page = $page ? $page : 1;
        $limit = $limit ? $limit : 10;
        $orderBy = $orderBy ? $orderBy : 'create_time';
        $order = $order ? $order : 'desc';
        
     	$itemList = db('ArticlesVerify')->where('uid',config('userId'))->page($page,$limit)->order($orderBy,$order)->select();
     	$itemCount = db('ArticlesVerify')->where('uid',config('userId'))->count();
	    return jsonSuccess('',['itemList' => $itemList,'total' => $itemCount,'page' => $page]);
    }

    public function itemDel()
    {
        $uuid = input('post.uuid');
        if (!$uuid) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('ArticlesVerify')->where('uuid',$uuid)->find();
        if (!$itemInfo) {
            return jsonError('删除项不存在');
        }
        if ($this->userId == $itemInfo['uid'] || $this->isUserAdmin) {
    		db('ArticlesVerify')->where('uuid',$uuid)->delete();
    	} else {
            return jsonError('无权限操作');
        }
     	return jsonSuccess('操作成功');
    }
    
    
}