<?php
namespace app\article\controller;
use think\Request;
use think\Response;
use think\Cache;
use app\common\controller\Base;

class ArticleComponent extends Base
{
    
    public function js()
    {
        $tempComponent = '';
        $pages = [];
        $pageTemplatePath = config('template.view_path') . 'article';
        $tempArray = explode(DS, $pageTemplatePath);
        $lastFileName = $tempArray[count($tempArray) - 1];
        if (preg_match('/^[a-zA-Z\s]+$/',$lastFileName)) {
            $vueFilePath = $pageTemplatePath . DS . 'vue' . DS;
            $vueFilePathArray = fetch_file_lists($vueFilePath);
            if ($vueFilePathArray) {
                foreach ($vueFilePathArray as $k => $v) {
                    if (strpos($v, '.vue') !== false) {
                        $vueArray = explode(DS, $v);
                        array_push($pages,['pagePath' => $v,'pageName' => $vueArray[count($vueArray) - 1]]);
                    }
                }
            }
        }
        if ($pages) {
            foreach ($pages as $key => $val) {
                $fileName = str_replace('.vue', '', $val['pageName']);
                $tempIndexData = $this->display(file_get_contents($val['pagePath']));
                preg_match_all('/<script>([\w\W]*)<\/script>/iU', $tempIndexData, $scriptResult);
                if ($scriptResult) {
                    $nameArray = explode('-', $fileName);
                    $ucName = '';
                    foreach ($nameArray as $k => $v) {
                        $ucName .= ucfirst($v);
                    }
                    preg_match_all('/<template>(.*?)<\/template>/is', $tempIndexData, $templateResult);
                    $tempComponent .= "const ".$ucName." = {";
                    $tempComponent .= "template: `".$templateResult[1][0]."`,";
                    $scriptResult[1][0] = str_replace('export default {', '', $scriptResult[1][0]);
                    $tempComponent .= $scriptResult[1][0];
                    $tempComponent .= "Vue.component('".$fileName."',".$ucName.");";
                    $tempComponent .= "Vue.component('".$ucName."',".$ucName.");";
                    $tempIndexData = '';
                    $scriptResult = '';
                    $templateResult = '';
                } 
            }
        }
        return Response::create($tempComponent)->contentType('application/x-javascript');
    }

    public function css()
    {
        $tempComponent = '';
        $pages = [];
        $pageTemplatePath = config('template.view_path') . 'article';
        $tempArray = explode(DS, $pageTemplatePath);
        $lastFileName = $tempArray[count($tempArray) - 1];
        if (preg_match('/^[a-zA-Z\s]+$/',$lastFileName)) {
            $cssFilePath = $pageTemplatePath . DS . 'vue' . DS;
            $cssFilePathArray = fetch_file_lists($cssFilePath);
            if ($cssFilePathArray) {
                foreach ($cssFilePathArray as $k => $v) {
                    if (strpos($v, '.vue') !== false) {
                        $cssArray = explode(DS, $v);
                        array_push($pages,['pagePath' => $v,'pageName' => $cssArray[count($cssArray) - 1]]);
                    }
                }
            }
        }
        if ($pages) {
            foreach ($pages as $key => $val) {
                $fileName = str_replace('.vue', '', $val['pageName']);
                $tempIndexData = $this->display(file_get_contents($val['pagePath']));
                preg_match_all('/<script>([\w\W]*)<\/script>/iU', $tempIndexData, $scriptResult);
                if ($scriptResult) {
                    preg_match_all('/<style>([\w\W]*)<\/style>/iU', $tempIndexData, $templateResult);
                    $tempComponent .=  $templateResult[1][0];
                } 
            }
        }
        return Response::create($tempComponent)->contentType('text/css');
    }
    
}
