<?php
//MIPJZ.COM [Don't forget the beginner's mind]
//Copyright (c) 2017~2099 http://www.ssycms.com All rights reserved.
namespace app\article\model;
use think\Cache;
use app\common\lib\Paginationm;
use app\common\lib\ChinesePinyin;
use think\Db;
use think\Controller;

class ArticlesComments extends Controller
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->item = 'ArticlesComments';
    }
    public function getItemListByTag($tag,$listType)
    {
        $tag = json_decode($tag,true);
        $whereArray = [];
        if (!$tag) {
            return false;
        }
        foreach ($tag as $key => $val) {
            if (strpos($key, 'where') !== false) {
                if (strpos($val, '=') !== false) {
                    $tempVal = explode('=', $val);
                    $whereArray[trim($tempVal[0])] = trim($tempVal[1]);
                }
                if (strpos($val, '<>') !== false) {
                    $tempVal = explode('<>', $val);
                    $whereArray[trim($tempVal[0])] = ['<>',trim($tempVal[1])];
                    break;
                }
                if (strpos($val, 'like') !== false) {
                    $tempVal = explode('like', $val);
                    $whereArray[trim($tempVal[0])] = ['like',trim($tempVal[1])];
                }
                if (strpos($val, '>') !== false) {
                    $tempVal = explode('>', $val);
                    $whereArray[trim($tempVal[0])] = ['>',trim($tempVal[1])];
                }
                if (strpos($val, '<') !== false) {
                    $tempVal = explode('<', $val);
                    $whereArray[trim($tempVal[0])] = ['<',trim($tempVal[1])];
                }
            }
        }
        $tag['whereArray'] = $whereArray;
        if ($listType == 'list') {
          	return $this->getItemList($tag);
        }
    }

    public function getItemList($paramData)
    {
        $itemId = $paramData['itemId'] ? $paramData['itemId'] : '';
        $page = $paramData['page'] ? $paramData['page'] : 1;
        $limit = $paramData['limit'] ? $paramData['limit'] : 10;
        $orderBy = $paramData['orderBy'] ? $paramData['orderBy'] : 'create_time';
        $order = $paramData['order'] ? $paramData['order'] : 'asc';
        $whereArray = $paramData['whereArray'] ? $paramData['whereArray'] : null;
        $itemList = [];
        if (!$itemId) {
        	$itemList = db('ArticlesComments')->page($page,$limit)->order($orderBy,$order)->select();
        } else {
        	$itemList = db('ArticlesComments')->where('item_id',$itemId)->page($page,$limit)->order($orderBy,$order)->select();
        }
        if ($itemList) {
            foreach($itemList as $k => $v) {
                $itemList[$k]['userInfo'] = model('app\user\model\Users')->getItemInfo($v['uid']);
                if (!$itemId) {
                	//仅管理员查询 前台不查询提升效率
                	$itemList[$k]['modInfo'] = model('app\article\model\Articles')->getItemInfo('',$v['item_id']);
                }
                $itemList[$k]['content'] = htmlspecialchars_decode($itemList[$k]['content']);
		        if (config('addonsInfo')['isFilterLink']) {
	        		$itemList[$k]['content'] = filterLink($itemList[$k]['content']);
		    	}
                
                $commentsList = db('ArticlesCommentsComments')->where('item_id',$v['id'])->limit($limit)->page($page)->order($orderBy, 'asc')->select();
	            if ($commentsList) {
	                foreach ($commentsList as $kk => $vv) {
	                    $commentsList[$kk]['userInfo'] = model('app\user\model\Users')->getItemInfo($vv['uid']);
	                    if ($vv['reply_item_id']) {
	                    	$commentsList[$kk]['replyInfo'] = db('ArticlesCommentsComments')->where('item_id',$vv['reply_item_id'])->find();
                			$commentsList[$kk]['replyInfo']['content'] = htmlspecialchars_decode($vv['content']);
					        if (config('addonsInfo')['isFilterLink']) {
	        					$commentsList[$kk]['replyInfo']['content'] = filterLink($commentsList[$kk]['replyInfo']['content']);
					    	}
	                    	$commentsList[$kk]['replyInfo']['userInfo'] = model('app\user\model\Users')->getItemInfo($vv['reply_uid']);
	                    }
	                }
	            }
	            $itemList[$k]['commentsList'] = $commentsList;
            }
            
        } else {
            $itemList = [];
        }
        return $itemList;
    }
    public function getPagination($paramData)
    {
        $itemId = $paramData['itemId'] ? $paramData['itemId'] : '';
        $page = $paramData['page'] ? $paramData['page'] : 1;
        $limit = $paramData['limit'] ? $paramData['limit'] : 10;
        $keywords = $paramData['keywords'] ? $paramData['keywords'] : null;
        $itemInfo = model('app\article\model\Articles')->getItemInfo('',$itemId);
        $count = $this->getCount($paramData);
        $baseUrl = $itemInfo['url'];
        $pagination_array = array(
            'base_url' => $baseUrl,
            'total_rows' => $count,
            'per_page' => $limit,
            'cur_page' => $page,
            'page_break' => '_'
        );
        $pagination = new Paginationm($pagination_array);
        return $pagination->create_links();
    }
    public function getCount($paramData)
    {
        $itemId = $paramData['itemId'] ? $paramData['itemId'] : '';
        if (!$itemId) {
            $count = db('ArticlesComments')->count();
        } else {
            $count = db('ArticlesComments')->where('item_id',$itemId)->count();
        }
        return $count;
    }

}