<?php
namespace app\article\model;
use app\common\lib\Paginationm;
use think\Db;
use think\Controller;

class ArticlesVerify extends Controller
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->itemType = 'article';
        $this->itemName = '内容';
        $this->item = 'Articles';
        $this->itemCategory = 'ArticlesCategory';
        $this->itemContent = 'ArticlesContent';
        $this->itemSearch = 'ArticlesSearch';
        $this->itemSearchRel = 'ArticlesSearchRel';
        $this->itemModelNameSpace = 'app\article\model\Articles';
        $this->itemCategoryModelNameSpace = 'app\article\model\ArticlesCategory';
        $this->itemTagsRelModelNameSpace = 'app\tag\model\TagsRel';
        $this->domain = config('domain');
        $this->settingInfo = config('settingInfo');
        $this->itemSettingInfo = config('articleSettingInfo');
    }
    
    
    public function getItemInfo($id = null,$uuid = null,$itemInfo = null)
    {
        if (!$id && !$uuid && !$itemInfo) {
            return false;
        }
        if (!$itemInfo) {
        	if ($id) {
            	$itemInfo = db('ArticlesVerify')->where('id',$id)->find(); 
        	}
        	if ($uuid) {
            	$itemInfo = db('ArticlesVerify')->where('uuid',$uuid)->find(); 
        	}
            if (!$itemInfo) {
                return false;
            }
        }
        if ($itemInfo) {
            return $itemInfo;
        }
    }
    
    public function getContentByItemInfo($itemInfo)
    {
        $itemInfo['content'] = htmlspecialchars_decode($itemInfo['content']);
        $itemInfo['mipContent'] = model('app\common\model\Common')->getContentFilterByContent($itemInfo['content']);
        return $itemInfo;
    }
    
}