<?php
namespace app\setting\controller;
use think\Db;
use think\Request;
use app\common\controller\AdminBase;

class ApiAdminBadWords extends AdminBase
{
    public function itemAdd()
    {
        $title = input('post.title');
        $itemInfo = db('BaseBadWords')->where('title',$title)->find();
        if ($itemInfo) {
            return jsonError('关键词已存在');
        }
        db('BaseBadWords')->insert(array('title' => trim($title)));
        return jsonSuccess('操作成功');
    }
    
    public function itemsAdd()
    {
        $names = input('post.names');
        $nameArray = explode(',', $names);
        if ($nameArray) {
            foreach ($nameArray as $key => $value) {
                if ($value) {
                    if (!db('BaseBadWords')->where('title',$value)->find()) {
                        db('BaseBadWords')->insert(array(
                            'title' => trim($value),
                        ));
                    };
                }
            }
        }
        return jsonSuccess('操作成功');
    }
    public function itemEdit()
    {
        $id = input('post.id');
        $title = input('post.title');
        $itemInfo = db('BaseBadWords')->where('id',$id)->find();
        db('BaseBadWords')->where('id',$id)->update(array('title' => trim($title)));
        return jsonSuccess('操作成功');
    }
	
    public function itemDel()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('BaseBadWords')->where('id',$id)->find();
        if (!$itemInfo) {
            return jsonError('删除项不存在');
        }
        db('BaseBadWords')->where('id',$id)->delete();
        return jsonSuccess('操作成功');
    }
    
    public function itemsDel()
    {
        $ids = input('post.ids');
        if (!$ids) {
          return jsonError('缺少参数');
        }
        $ids = explode(',', $ids);
        if ($ids) {
            foreach ($ids as $key => $value) {
                if (db('BaseBadWords')->where('id',$value)->find()) {
                    db('BaseBadWords')->where('id',$value)->delete();
                };
            }
        }
        return jsonSuccess('成功');
    }

    public function itemInfo()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        $itemInfo = db('BaseBadWords')->where('id',$id)->find();
	    return jsonSuccess('',$itemInfo);
    }
    
    public function itemList()
    {
        $keywords = input('post.keywords');
        $limit = input('post.limit');
        $page = input('post.page');
        if (empty($keywords)) {
            $keywordsWhere = null;
        } else {
            $keywords = explode(',',$keywords);
            foreach ($keywords as $key => $val) {
                if ($val) {
                    $sq[] = "%".$val."%";
                }
            }
            $keywordsWhere['title']  = ['like',$sq,'OR'];
        }
        $itemList = db('BaseBadWords')->where($keywordsWhere)->page($page,$limit)->order('id','asc')->select();
        $total = db('BaseBadWords')->where($keywordsWhere)->count();
        return jsonSuccess('',array('itemList' => $itemList,'total' => $total));
    }
}