<?php
namespace app\setting\model;
include_once ROOT_PATH . 'system' . DS . 'vendor' . DS . 'aliemail' . DS . 'aliyun-php-sdk-core' . DS . 'Config.php';
use Dm\Request\V20151123 as Dm;

use phpmailer\phpmailer;
use think\Request;
use think\Cache;
use think\Db;
use com\File;
use think\Controller;
class Email extends Controller
{
    public function sendEmail($email,$title = '',$html = '')
    {
        if (!$email) {
            return false;
        }
		if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
       		return ['code' => -1,'msg' => '邮箱格式错误'];
		}
        $keyInfo = config('keyInfo');
        if ($keyInfo['aliyunemailAccessKeyId']) {
        	if (!$keyInfo['aliyunemailAccessKeySecret']) {
        		return ['code' => -1,'msg' => '未配置邮件发送参数：AccessKeySecret'];
        	}
        	if (!$keyInfo['aliyunemailSendEmail']) {
        		return ['code' => -1,'msg' => '未配置邮件发送邮箱'];
        	}
	        $iClientProfile = \DefaultProfile::getProfile("cn-hangzhou", $keyInfo['aliyunemailAccessKeyId'], $keyInfo['aliyunemailAccessKeySecret']);     
	    	$client = new \DefaultAcsClient($iClientProfile);    
	    	$request = new Dm\SingleSendMailRequest();     
	     	$request->setAccountName($keyInfo['aliyunemailSendEmail']);
	    	$request->setFromAlias(config('settingInfo')['siteName']);
	    	$request->setAddressType(1);
	    	$request->setReplyToAddress("true");
	    	$request->setToAddress($email);
	    	$request->setSubject($title);
	    	$request->setHtmlBody($html);        
		    try {
		        $response = $client->getAcsResponse($request);
		        if ($response->EnvId) {
	         		return ['code' => 1];
		        }
		    } catch (ClientException  $e) {
				return ['code' => -1,'msg' => $e->getErrorMessage()];
		    } catch (ServerException  $e) {        
				return ['code' => -1,'msg' => $e->getErrorMessage()];
		    }
			return ['code' => -1,'msg' => '邮件发送失败'];
        } else {
       		if (!$keyInfo['AddonsEmailSendEmail']) {
        		return ['code' => -1,'msg' => '未配置邮件发送参数：邮箱'];
        	}
       		if (!$keyInfo['AddonsEmailSendPassword']) {
        		return ['code' => -1,'msg' => '未配置邮件发送参数：密码'];
        	}
       		if (!$keyInfo['AddonsEmailSendHost']) {
        		return ['code' => -1,'msg' => '未配置邮件发送参数：主机'];
        	}
       		if (!$keyInfo['AddonsEmailSendPort']) {
        		return ['code' => -1,'msg' => '未配置邮件发送参数：端口'];
        	}
		  	Vendor('phpmailer.phpmailer');   
		    try {
			  	$mail = new PHPMailer();
			  	$mail->IsSMTP();
			  	$mail->Host = $keyInfo['AddonsEmailSendHost'];
			  	$mail->Port = $keyInfo['AddonsEmailSendPort'];
			  	$mail->SMTPAuth = true;
			  	$mail->SMTPSecure = "ssl";
			  	$mail->CharSet = "UTF-8";
			  	$mail->Encoding = "base64";
			  	$mail->Username = $keyInfo['AddonsEmailSendEmail']; //网站服务端发给用户用的邮箱
			  	$mail->Password = $keyInfo['AddonsEmailSendPassword']; //网站服务端发给用户用的邮箱的密码
			  	$mail->Subject = $title;
				$mail->From = $keyInfo['AddonsEmailSendEmail']; //在用户邮件中显示的发件人
			  	$mail->FromName = config('settingInfo')['siteName'];
		   	 	$mail->AddAddress($email,'亲');
		      	$mail->IsHTML(true);
		      	$mail->Body = $html;
		      	if ($mail->Send()) {
		         	return ['code' => 1];
		      	}
		    } catch (\Exception $e) {
				return ['code' => -1,'msg' => $e];
		    }
			return ['code' => -1,'msg' => '邮件发送失败'];
        }
        
        
        
    }
    
  	public function sendRegEmail($email,$userInfo)
    {
    	$arr = range(1,9);
        shuffle($arr);
        $code = '';
        for ($i = 0; $i < 4; $i++) {
            $code .= $arr[$i];
        }
        $userToken = unid();
        $title = '用户注册';
        $html = '<p>Hi ' . $userInfo['username'] . '，欢迎加入 ' . config('settingInfo')['siteName'] . '。</p>';
        $html .= '<p>您的校验码是：' . $code . '</p>';
        $url = config('domain') . '/verifyEmailLink/?uid=' .  $userInfo['uid'] . '&token=' . $userToken;
        $html .= '<p>或者点击此链接激活你的账号：<a href="' . $url . '">' . $url . '</a></p>';
        $resArray = model('app\\setting\\model\\Email')->sendEmail($email,$title,$html);
        if ($resArray['code'] == 1) {
            db('UsersVerify')->insert(['uid' => $userInfo['uid'],'token' => $userToken,'code' => $code,'add_time' => time()]);
			return ['code' => 1,'msg' => '发送成功'];
        } else {
			return ['code' => -1,'msg' => $resArray['msg']];
        }
    }
    
  	public function sendForgetEmail($email)
    {
    	$arr = range(1,9);
        shuffle($arr);
        $code = '';
        for ($i = 0; $i < 4; $i++) {
            $code .= $arr[$i];
        }
        $title = '密码找回';
        $html = '<p>欢迎使用密码找回功能</p>';
        $html .= '<p>您的校验码是：' . $code . '</p>';
        $resArray = model('app\\setting\\model\\Email')->sendEmail($email,$title,$html);
        if ($resArray['code'] == 1) {
            Cache::set('emailCode' . $email, $code, 120);
			return ['code' => 1,'msg' => '发送成功'];
        } else {
			return ['code' => -1,'msg' => $resArray['msg']];
        }
    }
    
    
    
    
    
}

