<?php
namespace app\sitemap\controller;
use think\Request;
use think\Response;
use app\common\controller\Base;

class Sitemap extends Base
{
    public function sitemap()
    {
    	$num = 50000;
    	/*获取页码*/
        $page = input('param.pageId');
        /*初始化页码*/
        $page = $page ? $page : 0;
        /*判断页码*/
        if ($page > 0) {
        	/*统计总数*/
    		$count = db("Articles")->count();
    		/*判断*/
	    	if ($count <= $num) {
                throw new \think\exception\HttpException(404, 'sitemap不存在');
	    		return "";
	    	}
	    	/*总页码*/
	        $pageNum = ceil($count / $num);
		 	if ($pageNum < $page + 1) {
                throw new \think\exception\HttpException(404, 'sitemap不存在');
	    		return "";
		 	}
        	$data = ['page' => $page + 1,'limit' => $num,];
        } else {
        	$data = ['page' => 1,'limit' => $num,];
        }
        $itemList = model('app\article\model\Articles')->getItemList($data);
        $xml = '<?xml version="1.0" encoding="utf-8"?>';
        $xml .= '<urlset>';
        foreach($itemList as $k => $v) {
            $xml .= '<url>';
            $xml .= '<loc>' . $v["url"] . '</loc>';
            $xml .= '<lastmod>' . date("Y-m-d", $v["publish_time"]) . '</lastmod>';
            $xml .= '<changefreq>daily</changefreq>';
            $xml .= '<priority>0.6</priority>';
            $xml .= '</url>';
        }
        $xml .= '</urlset>';
        return Response::create($xml)->contentType('text/xml');
    }
    
    public function sitemapTag() {
		$num = 50000;
    	/*获取页码*/
        $page = input('param.pageId');
        /*初始化页码*/
        $page = $page ? $page : 0;
        /*判断页码*/
        if ($page > 0) {
        	/*统计总数*/
    		$count = db("Tags")->count();
    		/*判断*/
	    	if ($count <= $num) {
                throw new \think\exception\HttpException(404, 'sitemap不存在');
	    		return "";
	    	}
	    	/*总页码*/
	        $pageNum = ceil($count / $num);
		 	if ($pageNum < $page + 1) {
                throw new \think\exception\HttpException(404, 'sitemap不存在');
	    		return "";
		 	}
        	$page = $page + 1;
        } else {
        	$page = 1;
        }
        $itemList = db('Tags')->page($page,$num)->select();
        $xml = '<?xml version="1.0" encoding="utf-8"?>';
        $xml .= '<urlset>';
        foreach($itemList as $key => $val) {
            $url = model('app\tag\model\Tags')->getUrlByItemInfo($val);
            $time = $val['add_time'] ? date("Y-m-d", $val["add_time"]) : date("Y-m-d");
           	$xml .= '<url>';
            $xml .= '<loc>' . $url . '</loc>';
            $xml .= '<lastmod>' . $time . '</lastmod>';
            $xml .= '<changefreq>daily</changefreq>';
            $xml .= '<priority>0.9</priority>';
            $xml .= '</url>';
        }
        $xml .= '</urlset>';
        return Response::create($xml)->contentType('text/xml');
    }
    

}