<?php
namespace app\special\model;
use app\common\lib\Paginationm;
use think\Db;
use think\Controller;

class Specials extends Controller
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->domain = config('domain');
        $this->settingInfo = config('settingInfo');
    }
    
    public function itemDel($id)
    {
         
    }
    
    public function getItemInfo($id,$itemInfo = null)
    {
        if (!$id) {
            return false;
        }
        if (!$itemInfo) {
            $itemInfo = db('Specials')->where('id',$id)->find(); 
            if (!$itemInfo) {
                return false;
            }
        }
        if ($itemInfo) {
            $itemInfo['url'] = $this->getUrlByItemInfo($itemInfo);
            return $itemInfo;
        }
    }
    
    public function getUrlByItemInfo($itemInfo)
    {
        $domain = config('domain');
        $url = $domain . '/special/' . $itemInfo['url_name'] . '/';
        return $url;
    }

    public function getItemList($paramData)
    {
        $page = $paramData['page'] ? $paramData['page'] : 1;
        $limit = $paramData['limit'] ? $paramData['limit'] : 100000;
        $orderBy = $paramData['orderBy'] ? $paramData['orderBy'] : 'id';
        $order = $paramData['order'] ? $paramData['order'] : 'desc';
        $keywords = $paramData['keywords'] ? $paramData['keywords'] : null;
        $whereArray = $paramData['whereArray'] ? $paramData['whereArray'] : null;
        if ($keywords) {
            $keywords = explode(',',$keywords);
            foreach ($keywords as $key => $val) {
                if ($val) {
                    $sq[] = "%".$val."%";
                }
            }
            $keywordsWhere['title']  = ['like',$sq,'OR'];
        }
        $itemList = db('Specials')->where($keywordsWhere)->where($whereArray)->page($page,$limit)->order($orderBy,$order)->select();
        if ($itemList) {
            foreach($itemList as $k => $v) {
                $itemList[$k] = $this->getItemInfo($v['id'],$v);
            }
        } else {
            $itemList = [];
        }
        return $itemList;
    }
    
    
    public function getCrumb($tag)
    {
        $tag = json_decode($tag,true);
        $id = isset($tag['id']) ? $tag['id'] : '';
        $ulClass = isset($tag['ulClass']) ? $tag['ulClass'] : 'site-crumb';
        $liClass = isset($tag['liClass']) ? $tag['liClass'] : '';
        $isHome = isset($tag['isHome']) ? $tag['isHome'] : 1;
        $separator = isset($tag['separator']) ? $tag['separator'] : '';
        $type = isset($tag['type']) ? $tag['type'] : '';
        $itemId = isset($tag['itemId']) ? $tag['itemId'] : '';
        
        $itemInfo = $this->getItemInfo($id);
        $html = '<ul class="list-unstyled ' . $ulClass . '">';
        $html .= intval($isHome) === 1 ? '<li class="' . $liClass .'"><a href="'. $this->domain .'" title="'. $this->settingInfo['siteName'] .'">首页</a>'.$separator.'</li>' : '';
        $html .= '<li class="' . $liClass .'">';
        $html .= '<a href="'. $itemInfo['url'] .'" title="'. $itemInfo['title'] .'">';
        $html .= $itemInfo['title'];
        $html .= '</a>';
        $html .= '</li>';
        $html .= '</ul>';
        return $html;
    }
    
}