<?php
namespace app\user\controller;
use think\Request;
use app\common\controller\AdminBase;

class ApiAdminUserGroup extends AdminBase
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->itemModelNameSpace = 'app\user\model\Users';
        $this->itemName = $this->settingInfo['userModelName'];
        $this->item = 'Users';
        $this->itemCategory = 'UsersGroup';
        $this->itemType = 'users';
    }
    
    public function itemAdd()
    {
        $item = input('post.item/a');
        if (!$item['name']) {
      		return jsonError('请输入名称');
        }
        $itemCategoryInfo = db($this->itemCategory)->where('name',$item['name'])->find();
        if ($itemCategoryInfo) {
            return jsonError('分组存在');
        }
        $groupId = db($this->itemCategory)->insertGetId(array(
            'name' => $item['name'],
            'type' => $item['type'],
        ));
      	return jsonSuccess('添加成功');
    }

    public function itemDel()
    {
        $id = input('post.id');
        if (!$id) {
          return jsonError('缺少参数');
        }
        if (db($this->itemCategory)->where('group_id',$id)->find()) {
            db($this->itemCategory)->where('group_id',$id)->delete();
            return jsonSuccess('删除成功');
        } else {
            return  jsonError('不存在');
        }

    }
    
    public function itemList()
    {
        $data = $this->request->post();
        $data['orderBy'] = $data['orderBy'] ? $data['orderBy'] : 'group_id';
        $itemList = model('app\user\model\UsersGroup')->getGroupList($data);
        return jsonSuccess('',$itemList);
    }

    public function iteminfo()
    {
        $data = $this->request->post();
        $iteminfo = db('UsersGroup')->where('group_id',$data['id'])->find();
        return jsonSuccess('',$iteminfo);
    }

    public function itemEdit()
    {
        $id = input('post.id');
        $item = input('post.item/a');
        if (!$id) {
            return jsonError('缺少ID');
        }
        if (!$item['name']) {
            return jsonError('请输入名称');
        }

        $itemInfo = db($this->itemCategory)->where('group_id',$id)->find();
        if(!$itemInfo){
            return jsonError('分组不存在');
        }
        
        $itemInfo = db($this->itemCategory)->where('group_id','<>',$id)->where('name',$item['name'])->find();
        if ($itemInfo) {
          return jsonError('名称已存在，请重新输入');
        }
        db($this->itemCategory)->where('group_id',$id)->update([
            'name' => $item['name'],
            'type' => $item['type'],
        ]);
        return  jsonSuccess('修改成功');
    }
}