<?php
namespace app\user\controller;
include_once ROOT_PATH . 'system' . DS . 'vendor' . DS . 'alisms' . DS . 'SignatureHelper.php';
use think\Request;
use think\Validate;
use think\Cache;
use think\Db;
use think\Session;
use app\common\lib\Htmlp;
use app\common\controller\Init;
class ApiAliyunsms extends Init {
  
  	
    public function sendSms(Request $request) 
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
	    $token = input('post.__token__');
        $mobile = Htmlp::htmlp(input('post.mobile'));
        $codeType = Htmlp::htmlp(input('post.codeType'));
        $username = Htmlp::htmlp(input('post.username'));

    	$resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
	  	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
	  	}

	    $resData = model('app\\user\\model\\UsersCheck')->checkMobile($mobile);
	  	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
	  	}

        $num = 10; // 次数
        $s = 3600; //秒数
        $ip =  @Request::instance()->ip();
        $request = Request::instance();
        $ipList = cache($ip);
        cache($ip,$ipList . time() . '|');
        $ipList = cache($ip);
        if ($ipList) {
            $ipList = explode('|', $ipList);
            $tempArray = [];
            foreach ($ipList as $key => $value) {
                if ($value) {
                    if ($value > (time() - $s)) {
                        $tempArray[] = $value;
                    }
                }
            }
            if (count($tempArray) > $num) {
                return jsonError('您的IP发送验证码次数过多，请稍后再试','');
            }
        }

	    if ($codeType == 'reg') {
            $resData = model('app\\user\\model\\UsersCheck')->checkUserName($username);
            if ($resData['code'] == -1) {
                return jsonError($resData['msg']);
            }
            if (db('Users')->where('username',$username)->find()) {
                return jsonError('用户已存在');
            }
            if (db('Users')->where('mobile',$mobile)->find()) {
                return jsonError('手机号码已存在');
            }
	    }
    
	    if ($codeType == 'forget') {
	    	$userInfo = db('Users')->where('mobile',$mobile)->find();
            if (!$userInfo) {
                return jsonError('手机号不存在');
            }
	    }

	    $tempCache = Cache::get('messageCode' . md5(session_id()));
	    if ($tempCache) {
	        return jsonError('您上次获取的验证码尚未过期，请不要频繁发送！','');
	    }
	    Cache::set('messageCode' . md5(session_id()), time(), 60);
	    
	    $params = array ();
	    $accessKeyId = $this->keyInfo['aliyunsmsAccessKeyId'];
	    $accessKeySecret = $this->keyInfo['aliyunsmsAccessKeySecret'];
	    
	    $params["PhoneNumbers"] = $mobile;
	    //密码找回短信模板
	    if ($codeType == 'forget') {
	        $params["SignName"] = $this->keyInfo['aliyunsmsForgetSignName']; //签名名称
	        $params["TemplateCode"] = $this->keyInfo['aliyunsmsForgetTplCode']; //模板CODE
	    }
	    //注册短信模板
	    if ($codeType == 'reg') {
	        $params["SignName"] = $this->keyInfo['aliyunsmsRegSignName']; //签名名称
	        $params["TemplateCode"] = $this->keyInfo['aliyunsmsRegTplCode']; //模板CODE
	    }
	    $arr = range(1,9);
	    shuffle($arr);
	    $code = '';
	    for ($i = 0; $i<4; $i++) {
	        $code .= $arr[$i];
	    }
	    $params['TemplateParam'] = Array (
	        "code" => $code,
	    );
    	Cache::set('mobileCode' . $mobile, $code, 120);
	    if(!empty($params["TemplateParam"]) && is_array($params["TemplateParam"])) {
	        $params["TemplateParam"] = json_encode($params["TemplateParam"], JSON_UNESCAPED_UNICODE);
	    }
	    $helper = new \SignatureHelper();
	    $content = $helper->request(
	        $accessKeyId,
	        $accessKeySecret,
	        "dysmsapi.aliyuncs.com",
	        array_merge($params, array(
	            "RegionId" => "cn-hangzhou",
	            "Action" => "SendSms",
	            "Version" => "2017-05-25",
	        ))
	        // fixme 选填: 启用https
	        // ,true
	    );
	    return jsonSuccess('发送成功');
    }
}
