<?php
namespace app\user\controller;
use think\Request;
use think\Validate;
use think\Cache;
use think\Db;
use think\Session;
use app\common\lib\Htmlp;
use app\common\controller\Init;
class ApiEmail extends Init {
  
  	
    public function emailUpdate() 
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        if (!$this->userId) {
			return jsonError('尚未登录，无法操作');
        }
	    $token = input('post.__token__');
	    $email = Htmlp::htmlp(input('post.email'));
	    $verifyCode = Htmlp::htmlp(input('post.verifyCode'));
	    
	    if (!$verifyCode) {
			return jsonError('验证码不能为空');
	    }
	    
    	$resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
		$resData = model('app\\user\\model\\UsersCheck')->checkEmail($email);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
        }
      	
    	if (db('Users')->where('uid','<>',$this->userInfo['uid'])->where('email',$email)->find()) {
			return jsonError('邮箱已被占用');
	    }
	    
	    $verifyInfo = db('UsersVerify')->where('uid',$this->userInfo['uid'])->find();
	    if (!$verifyInfo) {
			return jsonError('验证码失效，请重新发送');
	    }
	    
	    if ($verifyInfo['code'] == $verifyCode) {
	    	db('Users')->where('uid',$this->userInfo['uid'])->update(['email' => $email,'verify_email' => 1]);
  			db('UsersVerify')->where('id',$verifyInfo['id'])->delete();
	    	return jsonSuccess('验证成功');
	    } else {
			return jsonError('验证码错误，请重新输入');
	    }

    }


    public function sendRegEmail()
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        if (!$this->userId) {
					return jsonError('尚未登录，无法操作');
        }
        $token = input('post.__token__');
        $email = Htmlp::htmlp(input('post.email'));

        $resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
        if ($resData['code'] == -1) {
            return jsonError($resData['msg']);
        }

        $resData = model('app\\user\\model\\UsersCheck')->checkEmail($email);
        if ($resData['code'] == -1) {
            return jsonError($resData['msg']);
        }

        if (db('Users')->where('uid','<>',$this->userInfo['uid'])->where('email',$email)->find()) {
            return jsonError('邮箱已被占用');
        }
        
        $userInfo = db('Users')->where('uid',$this->userId)->find();

        $num = 10; // 次数
        $s = 3600; //秒数
        $ip =  @Request::instance()->ip();
        $request = Request::instance();
        $ipList = cache($ip);
        cache($ip,$ipList . time() . '|');
        $ipList = cache($ip);
        if ($ipList) {
            $ipList = explode('|', $ipList);
            $tempArray = [];
            foreach ($ipList as $key => $value) {
                if ($value) {
                    if ($value > (time() - $s)) {
                        $tempArray[] = $value;
                    }
                }
            }
            if (count($tempArray) > $num) {
                return jsonError('您的IP发送校验码次数过多，请稍后再试','');
            }
        }
        $resArray = model('app\\setting\\model\\Email')->sendRegEmail($email,$userInfo);
       	if ($resArray['code'] == 1) {
            return jsonSuccess('发送成功');
        } else {
            return jsonError($resArray['msg']);
        }
    }

    public function sendForgetEmail()
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        $token = input('post.__token__');
        $email = Htmlp::htmlp(input('post.email'));

        $resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
        if ($resData['code'] == -1) {
            return jsonError($resData['msg']);
        }

        $resData = model('app\\user\\model\\UsersCheck')->checkEmail($email);
        if ($resData['code'] == -1) {
            return jsonError($resData['msg']);
        }

        if (!db('Users')->where('email',$email)->find()) {
            return jsonError('邮箱不存在');
        }

        $tempCache = Cache::get('emailCode' . md5(session_id()));
        if ($tempCache) {
            return jsonError('您上次获取的验证码尚未过期，请不要频繁发送！','');
        }
        Cache::set('emailCode' . md5(session_id()), time(), 120);

        $num = 10; // 次数
        $s = 3600; //秒数
        $ip =  @Request::instance()->ip();
        $request = Request::instance();
        $ipList = cache($ip);
        cache($ip,$ipList . time() . '|');
        $ipList = cache($ip);
        if ($ipList) {
            $ipList = explode('|', $ipList);
            $tempArray = [];
            foreach ($ipList as $key => $value) {
                if ($value) {
                    if ($value > (time() - $s)) {
                        $tempArray[] = $value;
                    }
                }
            }
            if (count($tempArray) > $num) {
                return jsonError('您的IP发送校验码次数过多，请稍后再试','');
            }
        }
        $resArray = model('app\\setting\\model\\Email')->sendForgetEmail($email);
       	if ($resArray['code'] == 1) {
            return jsonSuccess('发送成功');
        } else {
            return jsonError($resArray['msg']);
        }
        
    }


}
