<?php
namespace app\user\controller;
use think\Request;
use think\Validate;
use think\Session;
use think\Cache;
use app\common\lib\Htmlp;
use app\common\controller\Init;

class ApiUser extends Init
{
	
    public function token()
    {
        $token = $this->request->token('__token__', 'sha1');
        return jsonSuccess('',$token);
    }
    
    public function login()
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        $username = Htmlp::htmlp(trim(input('post.username')," \t\n\r\0\x0B"));
        $password = Htmlp::htmlp(trim(input('post.password')," \t\n\r\0\x0B"));
        $token = input('post.__token__');
        $captcha = input('post.captcha'); 
        
      	$resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
        if (config('settingInfo')['loginCaptcha']) {
            if(!captcha_check($captcha)) {
                return jsonError('验证码错误');
            }
        }
        if (!isset($username) || !$username) {
            return jsonError('请输入用户名');
        }
        if (!isset($password) || !$password) {
            return jsonError('请输入密码');
        }
        if (preg_match("/^1[3456789]{1}\d{9}$/",$username)) {
            $userInfo = db('Users')->where('mobile',$username)->find();
            if (!$userInfo) {
                $userInfo = db('Users')->where('username',$username)->find();
            }
        } else {
			if(filter_var($username, FILTER_VALIDATE_EMAIL)) {
            	$userInfo = db('Users')->where('email',$username)->find();
			}
            if (!$userInfo) {
                $userInfo = db('Users')->where('username',$username)->find();
            }
        }
        if (!$userInfo) {
            return jsonError('账号不存在');
        }
        $resData = model('app\\user\\model\\UsersCheck')->checkLoginIp($userInfo);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
        if (!config('settingInfo')['loginStatus']) {
            if ($userInfo['group_id'] != 1) {
                return jsonError('本站已关闭登录');
            }
        }
        if ($userInfo['status'] == 1) {
            return jsonError('你的账号被禁止登录');
        }
        if ($userInfo['password'] == create_md5($password,$userInfo['salt'])) {
            db('Users')->where('uid',$userInfo['uid'])->update(array(
                'last_login_time' => time(),
                'last_login_ip' => Request::instance()->ip(),
                'login_num' => $userInfo['login_num'] + 1,
            ));
            $userInfo['password'] = null;
            $userInfo['salt'] = null;
            $userInfo['money'] = '';
            $token = unid();
            db('UsersToken')->insert(array('uid' => $userInfo['uid'],'add_time' => time(),'token' => $token));
            cookie('userToken',$token,360000);
            model('app\common\model\Log')->itemAdd('登录成功，登录IP：' . Request::instance()->ip(),$userInfo['uid'],'login');
            return jsonSuccess('登录成功',$userInfo);
        } else {
       		model('app\\user\\model\\UsersCheck')->updateLoginIp($userInfo);
            return jsonError('账号或密码不正确');
        }

    }

    public function reg()
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        if (!$this->settingInfo['registerStatus']) {
            return jsonError('该功能已被管理员关闭');
        }
        
      	$resData = model('app\\user\\model\\UsersCheck')->checkRegIp();
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
        $username = Htmlp::htmlp(trim(input('post.username')," \t\n\r\0\x0B"));
        $password = Htmlp::htmlp(trim(input('post.password')," \t\n\r\0\x0B"));
        $reference = Htmlp::htmlp(trim(input('post.reference')," \t\n\r\0\x0B"));
       	$email = Htmlp::htmlp(trim(input('post.email')," \t\n\r\0\x0B"));
       	$mobile = Htmlp::htmlp(trim(input('post.mobile')," \t\n\r\0\x0B"));
        $verifyCode = Htmlp::htmlp(trim(input('post.verifyCode')," \t\n\r\0\x0B"));
        $token = input('post.__token__');
        $captcha = input('post.captcha');
        
      	$resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
        if ($this->settingInfo['registerCaptcha']) {
            if(!captcha_check($captcha)) {
                return jsonError('验证码错误');
            }
        }
        
      	$resData = model('app\\user\\model\\UsersCheck')->checkUserName($username);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
      	$resData = model('app\\user\\model\\UsersCheck')->checkEmail($email);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
      	$resData = model('app\\user\\model\\UsersCheck')->checkPassword($password);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	
        if (db('Users')->where('username',$username)->find()) {
            return jsonError('用户已存在');
        }
		if (db('Users')->where('email',$email)->find()) {
			return jsonError('邮箱已存在');
	    }
	    
        if ($this->keyInfo['userRegVerify'] == 'sms') {
        	if (!$verifyCode) {
	         	return jsonError('请输入校验码');
        	}
	      	$resData = model('app\\user\\model\\UsersCheck')->checkMobile($mobile);
	      	if ($resData['code'] == -1) {
		        return jsonError($resData['msg']);
	      	}
	        if (db('Users')->where('mobile',$mobile)->find()) {
	            return jsonError('手机号码已存在');
	        }
            $mobileCode = Cache::get('mobileCode' . $mobile);
	        if (!$mobileCode) {
	            return jsonError('校验码已过期');
	        }
            if ($verifyCode != $mobileCode) {
                return jsonError('校验码错误，请重新获取');
            }
        }
        
        $data = [
        	'groupId' => 2,
        	'username' => $username,
        	'password' => $password,
        	'reference' => $reference,
        	'mobile' => $mobile,
        	'email' => $email,
        ];
        $userInfo = model('app\user\model\Users')->itemAdd($data);
        if ($userInfo) {
	      	model('app\\user\\model\\UsersCheck')->updateRegIp();
	      	db('Users')->where('uid',$userInfo['uid'])->update(array(
                'last_login_time' => time(),
                'last_login_ip' => Request::instance()->ip(),
                'login_num' => 1,
            ));
            $token = unid();
            db('UsersToken')->insert(array('uid' => $userInfo['uid'],'add_time' => time(),'token' => $token));
            cookie('userToken',$token,360000);
            if ($this->keyInfo['userRegVerify'] == 'email') {
		       	model('app\\setting\\model\\Email')->sendRegEmail($email,$userInfo);
            }
            return jsonSuccess('注册成功');
        } else {
            return jsonError('注册失败');
        }
        
    }
    
    public function userForget()
    {
	    if (!Request::instance()->isPost()) {
	        return jsonError('请求方式错误');
	    }
        $mobile = Htmlp::htmlp(trim(input('post.mobile')," \t\n\r\0\x0B"));
        $email = Htmlp::htmlp(trim(input('post.email')," \t\n\r\0\x0B"));
        $password = Htmlp::htmlp(trim(input('post.password')," \t\n\r\0\x0B"));
        $verifyCode = Htmlp::htmlp(trim(input('post.verifyCode')," \t\n\r\0\x0B"));
        $token = input('post.__token__');
        
        if (!$verifyCode) {
         	return jsonError('请输入校验码');
    	}
    	
        $resData = model('app\\user\\model\\UsersCheck')->checkToken($token);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
      	$resData = model('app\\user\\model\\UsersCheck')->checkPassword($password);
      	if ($resData['code'] == -1) {
	        return jsonError($resData['msg']);
      	}
        
        if ($this->keyInfo['userRegVerify'] == 'sms') {
	      	$resData = model('app\\user\\model\\UsersCheck')->checkMobile($mobile);
	      	if ($resData['code'] == -1) {
		        return jsonError($resData['msg']);
	      	}
	        $userInfo = db('Users')->where('mobile',$mobile)->find();
	        if (!$userInfo) {
	            return jsonError('手机号码不存在');
	        }
	        $mobileCode = Cache::get('mobileCode' . $mobile);
	        if (!$mobileCode) {
	            return jsonError('校验码已过期');
	        }
	        if ($verifyCode != $mobileCode) {
	            return jsonError('校验码错误，请重新获取');
	        }
        } else {
	        $resData = model('app\\user\\model\\UsersCheck')->checkEmail($email);
	      	if ($resData['code'] == -1) {
		        return jsonError($resData['msg']);
	      	}
	        $userInfo = db('Users')->where('email',$email)->find();
	        if (!$userInfo) {
	            return jsonError('邮箱不存在');
	        }
	        $emailCode = Cache::get('emailCode' . $email);
	        if (!$emailCode) {
	            return jsonError('校验码已过期');
	        }
	        if ($verifyCode != $emailCode) {
	            return jsonError('校验码错误，请重新获取');
	        }
        }
        
        $md5Password = create_md5($password,$userInfo['salt']);
        db('Users')->where('uid',$userInfo['uid'])->update(array(
            'password' => $md5Password,
        ));
        return jsonSuccess('ok');
    }
   
}