<?php
namespace app\user\controller;
use think\Request;
use think\Session;
use think\Validate;
use think\Cache;
use app\common\controller\Base;

class UserLogin extends Base
{
    public function login()
    {
        if ($this->userId) {
            $this->redirect($this->domain,302);
        }
        if (!$this->settingInfo['loginStatus']) {
            $this->error('本站已关闭登录功能');
        }
        $returnUrl = @htmlspecialchars($_SERVER['HTTP_REFERER']);
        //来路地址判断，部分来路地址返回到首页
        if (strpos($returnUrl,'forget') !== false) {
        	$returnUrl = config('domain');
        }
        if (strpos($returnUrl,'register') !== false) {
        	$returnUrl = config('domain');
        }
        $this->assign('returnUrl', $returnUrl);
        
        return $this->siteView('user/login');
    }
    public function register()
    {
        if ($this->userId) {
            $this->redirect($this->domain,302);
        }
        if (!$this->settingInfo['registerStatus']) {
            $this->error('本站已关闭注册功能');
        }
        
        $reference = input('param.reference');
        $this->assign('reference', $reference);
        
        return $this->siteView('user/register');
    }
    
    public function forget()
    {
        return $this->siteView('user/forget');
    }
    
    public function logOut()
    {
        $userToken = cookie('userToken');
        db('UsersToken')->where('token',$userToken)->delete();
        model('app\common\model\Log')->itemAdd('退出成功，退出IP：' . Request::instance()->ip(),config('userId'),'login');
        cookie('userToken', null);
        $this->success('退出成功','/');
    }
    
}