<?php
namespace app\user\model;
use think\Cache;
use think\Request;
use think\Validate;
use app\common\lib\Paginationm;
use think\Db;
use think\Controller;

class Users extends Controller
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->item = 'Users';
        $this->itemType = 'user';
        $this->itemName = '用户';
        $this->itemContent = 'UsersContent';
        $this->itemCategory = 'UsersGroup';
        $this->itemModelNameSpace = 'app\user\model\Users';
        $this->itemCategoryModelNameSpace = 'app\user\model\UsersGroup';
        
        $this->settingInfo = config('settingInfo');
    }
    /**
     *  用户添加
     */
    public function itemAdd($data,$fieldList = [])
    {
    	$avatar = '';
        $keyInfo = config('keyInfo');
        $avatarType = $keyInfo['avatarType'] ? $keyInfo['avatarType'] : 'one';
        $numArray = ['a','b','c','d','e','f','g','h','i','j','k','m','l','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9'];
        $index = rand(0,35);
    	$str = $numArray[$index];
    	$filePath = ROOT_PATH . 'avatar' . DS . $avatarType . DS . $avatarType . '_' . $str . '.jpg';
    	if (is_file($filePath)) {
    		$avatar = '/avatar/' . $avatarType . '/' . $avatarType . '_' . $str . '.jpg';
    	}
        $salt = create_salt(8);
        $resArray = array (
            'uid' => uuid(),
            'username' => $data['username'],
            'password' => create_md5($data['password'],$salt),
            'salt' => $salt,
            'reg_time' => time(),
            'reg_ip' => Request::instance()->ip(),
            'email' => $data['email'],
            'group_id' => $data['groupId'] ? $data['groupId'] : 2,
            'mobile' => $data['mobile'],
            'avatar' => $avatar,
            'rank' => 1,
            'terminal' => (isset($data['terminal']) && $data['terminal']) ? $data['terminal'] : 'pc',
            'reference' => $data['reference']
        );
        db($this->item)->insert($resArray);
        //更新总数量 
        $allTotal = db('Users')->count();
        if (db('BaseKey')->where('key','user_num')->find()) {
        	db('BaseKey')->where('key','user_num')->update(array('val' => $allTotal));
        } else {
        	db('BaseKey')->insert(array('key' => 'user_num','val' => $allTotal));
        }
        return $resArray;
    }
	
    public function itemDel($uuid)
    {
        $itemInfo = db($this->item)->where('uid',$uuid)->find();
        if (!$itemInfo) {
            return false;
        }
        db($this->item)->where('uid',$uuid)->delete();
        return true;
    }
    
    public function getItemInfo($id = null,$userName = null)
    {
        if ($id) {
            $itemInfo = db($this->item)->where('uid',$id)->find();
        }
        if ($userName) {
            $itemInfo = db($this->item)->where('username',$userName)->find();
        }
        if (!$itemInfo["username"] || !$itemInfo) {
            if (SITE_HOST) {
                $itemInfo['avatar'] = '/public/assets/common/images/avatar.jpg';
            } else {
                $itemInfo['avatar'] = '/assets/common/images/avatar.jpg';
            }
            $itemInfo["username"] = "匿名用户";
            $itemInfo['nickname'] = $itemInfo['username'];
            return $itemInfo;
        }
        if ($itemInfo) {
            $itemInfo['url'] = $this->getUrlByItemInfo($itemInfo);
            $itemInfo['groupInfo'] = model($this->itemCategoryModelNameSpace)->getGroupInfo($itemInfo['group_id']);
            $itemInfo['nickname'] = $itemInfo['nickname'] ? $itemInfo['nickname'] : $itemInfo['username'];
            $itemInfo['signature'] = htmlspecialchars_decode($itemInfo['signature']);
            
       		$itemInfo['blogInfo']['domain'] = config('domain')  . '/p/' . $itemInfo['blogInfo']['url_name'] . '/';
	    	try {
	            $itemInfo['blogInfo'] = db('Blog')->where('uid',$itemInfo['uid'])->find();
        		$itemInfo['blogInfo']['domain'] = config('domain')  . '/' . $itemInfo['blogInfo']['url_name'] . '/';
		    } catch (\Exception $e) {}
            if (SITE_HOST) {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/public/assets/common/images/avatar.jpg';
            } else {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/assets/common/images/avatar.jpg';
            }
            $itemInfo['password'] = null;
            $itemInfo['salt'] = null;
            $itemInfo['money'] = null;
            return $itemInfo;
        } else {
            return false;
        }
    }
    
    public function getItemAllInfo($id = null,$userName = null)
    {
        if ($id) {
            $itemInfo = db($this->item)->where('uid',$id)->find();
        }
        if ($userName) {
            $itemInfo = db($this->item)->where('username',$userName)->find();
        }
        if ($id == null) {
            if (SITE_HOST) {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/public/assets/common/images/avatar.jpg';
            } else {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/assets/common/images/avatar.jpg';
            }
            return $itemInfo;
        }
        if ($itemInfo) {
            $itemInfo['url'] = $this->getUrlByItemInfo($itemInfo);
            $itemInfo['groupInfo'] = model($this->itemCategoryModelNameSpace)->getGroupInfo($itemInfo['group_id']);
            $itemInfo['nickname'] = $itemInfo['nickname'] ? $itemInfo['nickname'] : $itemInfo['username'];
            $itemInfo['signature'] = htmlspecialchars_decode($itemInfo['signature']);
	    	try {
	            $itemInfo['blogInfo'] = db('Blog')->where('uid',$itemInfo['uid'])->find();
        		$itemInfo['blogInfo']['domain'] = config('domain')  . '/' . $itemInfo['blogInfo']['url_name'] . '/';
		    } catch (\Exception $e) {}
            if (SITE_HOST) {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/public/assets/common/images/avatar.jpg';
            } else {
                $itemInfo['avatar'] =  $itemInfo['avatar'] ? $itemInfo['avatar'] : '/assets/common/images/avatar.jpg';
            }
            $itemInfo['password'] = null;
            $itemInfo['salt'] = null;
            return $itemInfo;
        } else {
            return false;
        }
    }
    
    public function getItemListByTag($tag,$listType)
    {
        $tag = json_decode($tag,true);
        $whereArray = [];
        foreach ($tag as $key => $val) {
            if (strpos($key, 'where') !== false) {
                if (strpos($val, '=') !== false) {
                    $tempVal = explode('=', $val);
                    $whereArray[trim($tempVal[0])] = trim($tempVal[1]);
                }
                if (strpos($val, 'like') !== false) {
                    $tempVal = explode('like', $val);
                    $whereArray[trim($tempVal[0])] = ['like',trim($tempVal[1])];
                }
                if (strpos($val, '>') !== false) {
                    $tempVal = explode('>', $val);
                    $whereArray[trim($tempVal[0])] = ['>',trim($tempVal[1])];
                }
                if (strpos($val, '<') !== false) {
                    $tempVal = explode('<', $val);
                    $whereArray[trim($tempVal[0])] = ['<',trim($tempVal[1])];
                }
            }
        }
        $cid = isset($tag['cid']) ? $tag['cid'] : null;
        $uid = isset($tag['uid']) ? $tag['uid'] : null;
        $page = isset($tag['page']) ? $tag['page'] : 1;
        $orderBy = isset($tag['orderBy']) ? $tag['orderBy'] : 'uid';
        $order = isset($tag['order']) ? $tag['order'] : 'desc';
        $limit = isset($tag['limit']) ? $tag['limit'] : 10;
        $where = isset($tag['where']) ? $tag['where'] : null;
        
        $type = isset($tag['type']) ? $tag['type'] : '';
        
        if ($listType == 'list') {
            return $this->getItemList($cid, $page, $limit, $orderBy, $order, $where,$keywords,$whereArray);
        }
        if ($listType == 'info') {
            return $this->getItemInfo($uid);
        }
        
    }

    public function getItemList($cid = null, $page = 1, $perPage = 10, $orderBy = 'uid', $order = 'desc', $where = null,$keywords = null,$whereArray = null,$uids = null)
    {
        $orderBy = $orderBy ? $orderBy : 'uid';
        $order = $order ? $order : 'desc';
        $keywordsWhere = null;
        if ($keywords) {
            $keywords = explode(',',$keywords);
            foreach ($keywords as $key => $val) {
                if ($val) {
                    $sq[] = "%".$val."%";
                }
            }
            $keywordsWhere['username']  = ['like',$sq,'OR'];
        }
        if (empty($uids)) {
            $uidsWhere = null;
        } else {
            $uids = explode(',',$uids);
            $uidsWhere['uid']  = ['in',$uids];
        }
        
        $itemList = [];
        if ($cid == '' || $cid == null) {
            $itemList = db($this->item)->where($where)->where($keywordsWhere)->where($uidsWhere)->where($whereArray)->page($page,$perPage)->order($orderBy,$order)->select();
        } else {
            $itemList = db($this->item)->where($where)->where($keywordsWhere)->where($uidsWhere)->where($whereArray)->where('group_id',$cid)->page($page,$perPage)->order($orderBy,$order)->select();
        }
        if ($itemList) {
            foreach($itemList as $k => $v) {
                $itemList[$k]['groupInfo'] = model($this->itemCategoryModelNameSpace)->getGroupInfo($v['group_id']);
                $itemList[$k]['nickname'] = $itemList[$k]['nickname'] ? $itemList[$k]['nickname'] : $itemList[$k]['username'];
            	$itemList[$k]['signature'] = htmlspecialchars_decode($itemList[$k]['signature']);
		    	try {
		            $itemList[$k]['blogInfo'] = db('Blog')->where('uid',$itemList[$k]['uid'])->find();
	        		$itemList[$k]['blogInfo']['domain'] = config('domain')  . '/' . $itemList[$k]['blogInfo']['url_name'] . '/';
			    } catch (\Exception $e) {}
                if (SITE_HOST) {
                    $itemList[$k]['avatar'] =  $itemList[$k]['avatar'] ? $itemList[$k]['avatar'] : '/public/assets/common/images/avatar.jpg';
                } else {
                    $itemList[$k]['avatar'] =  $itemList[$k]['avatar'] ? $itemList[$k]['avatar'] : '/assets/common/images/avatar.jpg';
                }
                
            }
            foreach($itemList as $k => $v) {
                $itemList[$k]['url'] = $this->getUrlByItemInfo($v);
                $itemList[$k]['password'] = null;
                $itemList[$k]['salt'] = null;
                $itemList[$k]['money'] = null;
            }
        } else {
            $itemList = [];
        }
        return $itemList;
    }
	
    public function getCount($cid = null,$where = null, $keywords = null,$whereArray = null)
    {
        $count = 0;
        if (empty($keywords)) {
            $keywordsWhere = null;
        } else {
            $keywords = explode(',',$keywords);
            foreach ($keywords as $key => $val) {
                if ($val) {
                    $sq[] = "%".$val."%";
                }
            }
            $keywordsWhere['username']  = ['like',$sq,'OR'];
        }
        if ($cid == '' || $cid == null) {
            $count = db($this->item)->where($where)->where($keywordsWhere)->where($whereArray)->page($page,$perPage)->count();
        } else {
            $itemCategoryList = db($this->itemCategory)->where('group_id',$cid)->select();
            if ($itemCategoryList) {
                foreach ($itemCategoryList as $key => $value) {
                    $cids[] = $value['id'];
                }
            }
            if ($itemCategoryList) {
                $count = db($this->item)->where($where)->where($keywordsWhere)->where($whereArray)->whereOr('group_id',$cid)->whereOr('group_id','in',$cids)->page($page,$perPage)->count();
            } else {
                $count = db($this->item)->where($where)->where($keywordsWhere)->where($whereArray)->where('group_id',$cid)->page($page,$perPage)->count();
            }
        }
        return $count;
    }
    
    public function getUrlByItemInfo($item,$domain = null)
    {
        $domain = $domain ? $domain : config('domain');
        $res = $domain . '/u/' . $item['uid'] . '/';
        return $res;
    }
    
     /**
     * 根据分类ID查询权限
     */
    public function getUserGroupExtendData($cid = 0,$groupId = null,$categoryInfo = null)
    {
    	$userInfo = config('userInfo');
    	$groupId = $groupId ? $groupId : $userInfo['group_id'];
		$data = $this->getUserGroupExtendInfo($groupId,0);
    	return $data;
    }
    
    public function getUserGroupExtendInfo($groupId,$cid = 0)
    {
    	$data = [];
		$userGroupExtendInfo = db('UsersGroupExtend')->where('cid',$cid)->where("item_id",$groupId)->find();
		if (!$userGroupExtendInfo) {
    		$data['avatarUpload'] = 1;
		} else {
			$jsonStr = $userGroupExtendInfo['data'] ? $userGroupExtendInfo['data'] : "[]";
    		$dataArray = json_decode($jsonStr,true);
    		$data['avatarUpload'] = isset($dataArray['avatarUpload']) ? intval($dataArray['avatarUpload']) : 1;
		}
    	return $data;
    }

    
}