<?php
namespace app\user\model;
use think\Cache;
use app\common\lib\Paginationm;
use app\common\lib\ChinesePinyin;
use think\Db;
use think\Controller;

class UsersGroup extends Controller
{
    protected $beforeActionList = ['start'];
    public function start() {
        $this->item = 'Users';
        $this->itemType = 'user';
        $this->itemName = '用户';
        $this->itemContent = 'UsersContent';
        $this->itemCategory = 'UsersGroup';
        $this->itemModelNameSpace = 'app\user\model\Users';
        $this->itemCategoryModelNameSpace = 'app\user\model\UsersGroup';
        
        $categoryListData = [];
        $categoryAllListData = [];
        $categoryAllListData = db('UsersGroup')->order('sort asc')->select();
        if ($categoryAllListData) {
            foreach ($categoryAllListData as $key => $value) {
                $categoryListData[$value['group_id']] = $value;
            }
        }
        config('userCategoryAllListData',$categoryAllListData);
        config('userCategoryListData',$categoryListData);
        
        $this->categoryListData = config('userCategoryListData');
        $this->categoryAllListData = config('userCategoryListData');
        $this->settingInfo = config('settingInfo');
    }
    
    public function getCategoryByTag($tag)
    {
        $tag = json_decode($tag,true);
        $whereArray = [];
        foreach ($tag as $key => $val) {
            if (strpos($key, 'where') !== false) {
                if (strpos($val, '=') !== false) {
                    $tempVal = explode('=', $val);
                    $whereArray[trim($tempVal[0])] = trim($tempVal[1]);
                }
                if (strpos($val, 'like') !== false) {
                    $tempVal = explode('like', $val);
                    $whereArray[trim($tempVal[0])] = ['like',trim($tempVal[1])];
                }
                if (strpos($val, '>') !== false) {
                    $tempVal = explode('>', $val);
                    $whereArray[trim($tempVal[0])] = ['>',trim($tempVal[1])];
                }
                if (strpos($val, '<') !== false) {
                    $tempVal = explode('<', $val);
                    $whereArray[trim($tempVal[0])] = ['<',trim($tempVal[1])];
                }
            }
        }
        $tag['whereArray'] = $whereArray;
        return $this->getGroupList($tag);
        
    }
    public function getGroupInfo($groupId)
    {
        if (!$groupId) {
        	return false;
        }
        $itemCategoryInfo = $this->categoryListData[$groupId];
        return $itemCategoryInfo;
    }
    
    public function getGroupList($paramData)
    {
    	$type = $paramData['type'] ? $paramData['type'] : '';
        $page = $paramData['page'] ? $paramData['page'] : 1;
        $limit = $paramData['limit'] ? $paramData['limit'] : 10;
        $orderBy = $paramData['orderBy'] ? $paramData['orderBy'] : 'group_id';
        $order = $paramData['order'] ? $paramData['order'] : 'asc';
        
        $itemCategoryList = null;
        if ($type === '' || $type === null) {
            $itemCategoryList = db($this->itemCategory)->where($where)->limit($limit)->order($orderBy,$order)->select();
        } else {
            $itemCategoryList = db($this->itemCategory)->where('type',$type)->where($where)->limit($limit)->order($orderBy,$order)->select();
        }
        if($itemCategoryList) {
            foreach ($itemCategoryList as $key => $val) {
                $itemCategoryList[$key] = $this->getGroupInfo($val['group_id']);
            }
        }

        return $itemCategoryList;
    }
    
}