DROP TABLE IF EXISTS `base_addons`;
CREATE TABLE `base_addons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `author` varchar(255) DEFAULT NULL,
  `version` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `config` text,
  `is_admin` int(1) DEFAULT 0,
  `is_side` int(1) DEFAULT 0,
  `is_header` int(1) DEFAULT 0,
  `is_global` int(1) DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `is_global` (`is_global`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_domain`;
CREATE TABLE `base_domain` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `http_type` varchar(255) DEFAULT NULL,
  `domain` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `data` text,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `domain` (`domain`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_ip`;
CREATE TABLE `base_ip` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(255) DEFAULT NULL,
  `status` int(1) DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `ip` (`ip`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_key`;
CREATE TABLE `base_key` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(255) NOT NULL,
  `val` text,
  PRIMARY KEY (`id`),
  KEY `key` (`key`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_log`;
CREATE TABLE `base_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `time` int(11) DEFAULT NULL,
  `info` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_settings`;
CREATE TABLE `base_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(255) NOT NULL,
  `val` text,
  PRIMARY KEY (`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=49 DEFAULT CHARSET=utf8;

INSERT INTO `base_settings` VALUES 	(1,'siteName', 'UGCCMS内容管理系统'),	('2', 'indexTitle', '-UGC社交化内容管理系统'),	('3', 'diyTitle', ''),	('4', 'description', ''),	('5', 'keywords', ''),	('6', 'template', 'default'),	('7', 'rewrite', ''),	('8', 'httpType', 'http://'),	('9', 'topDomain', ''), 	('10', 'runUrl', ''),	('11', 'domain', ''), 	('12', 'uploadUrl', 'uploads'),	('13', 'statistical', ''),	('14', 'icp', ''),	('15', 'codeCompression', ''), 	('16', 'systemStatus', '1'), 	('17', 'systemType', 'cms'), 	('18', 'articleModelName', '文章'), 	('19', 'articleModelUrl', 'article'),	('20', 'tagModelName', '标签'), 	('21', 'tagModelUrl', 'tag'),	('22', 'loginStatus', '1'),	('23', 'registerStatus', ''),	('24', 'loginCaptcha', '1'),	('25', 'registerCaptcha', '1'),	('26', 'localCurrentVersionNum', '109'), 	('27', 'localCurrentVersion', 'v1.0.9'),	('28', 'titleSeparator', '_'),	('29', 'urlPageBreak', '_'),  	('30', 'baiduMipApi', ''),	('31', 'baiduMipApiStatus', ''), ('32', 'baiduTimeApi', null), ('33', 'baiduTimeApiStatus', ''), ('34', 'superSites', ''), ('35', 'superTpl', ''), ('36', 'systemTable', ''), ('37', 'smApi', ''), ('38', 'smApiStatus', ''), ('39', 'data', ''), ('40', 'isDiyNav', ''), ('41', 'systemCode', ''), ('42', 'xzhRealtimeApi', ''), ('43', 'xzhRealtimeApiStatus', ''), ('44', 'xzhBatchApi', ''), ('45', 'xzhBatchApiStatus', ''), ('46', 'xzhId', ''), ('47', 'baiduDailyApi', ''), ('48', 'baiduDailyApiStatus', '');
DROP TABLE IF EXISTS `base_msg`;
CREATE TABLE `base_msg` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `status` int(1) DEFAULT 0,
  `add_time` int(11) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `item_uid` char(32) DEFAULT NULL,
  `item_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  `answer_id` char(32) DEFAULT NULL,
  `answer_comments_id` char(32) DEFAULT NULL,
  `answer_comments_reply_id` char(32) DEFAULT NULL,
  `comments_id` char(32) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `status` (`status`),
  KEY `type` (`type`),
  KEY `item_id` (`item_id`),
  KEY `item_type` (`item_type`),
  KEY `add_time` (`add_time`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `base_admin`;
CREATE TABLE `base_admin` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `cid` int(11) NOT NULL DEFAULT '0',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `nickname` varchar(32) DEFAULT NULL COMMENT '昵称',
  `password` varchar(32) DEFAULT NULL COMMENT '密码',
  `salt` varchar(10) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL COMMENT '用户邮箱',
  `mobile` varchar(15) DEFAULT NULL COMMENT '用户手机',
  `qq` varchar(13) DEFAULT NULL,
  `sex` tinyint(1) NOT NULL DEFAULT '1' COMMENT '性别（1-男，2-女）',
  `login_num` int(11) NOT NULL DEFAULT '0' COMMENT '登录次数',
  `reg_ip` varchar(20) DEFAULT NULL COMMENT '注册IP',
  `reg_time` int(11) DEFAULT NULL COMMENT '注册时间',
  `last_login_ip` varchar(20) DEFAULT NULL COMMENT '最后登录IP',
  `last_login_time` int(11) DEFAULT NULL COMMENT '最后登录时间',
  `signature` varchar(255) DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '用户状态 1为停止使用',
  `terminal` varchar(5) NOT NULL DEFAULT 'pc' COMMENT '用户终端',
  `integral` int(11) NOT NULL DEFAULT '0',
  `money` decimal(11,2) DEFAULT '0.00',
  `avatar` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `username` (`username`),
  KEY `reg_time` (`reg_time`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_admin_token`;
CREATE TABLE `base_admin_token` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  `end_time` int(11) DEFAULT NULL,
  `terminal` varchar(10) NOT NULL DEFAULT '',
  `token` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `add_time` (`add_time`),
  KEY `end_time` (`end_time`),
  KEY `token` (`token`),
  KEY `terminal` (`terminal`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `base_bad_words`;
CREATE TABLE `base_bad_words` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `title` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `nickname` varchar(32) DEFAULT NULL COMMENT '昵称',
  `password` varchar(32) DEFAULT NULL COMMENT '密码',
  `salt` varchar(10) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL COMMENT '用户邮箱',
  `mobile` varchar(15) DEFAULT NULL COMMENT '用户手机',
  `qq` varchar(13) DEFAULT NULL,
  `sex` tinyint(1) NOT NULL DEFAULT '1' COMMENT '性别（1-男，2-女）',
  `group_id` int(11) NOT NULL DEFAULT '2',
  `rank` tinyint(4) DEFAULT NULL COMMENT '等级',
  `login_num` int(11) NOT NULL DEFAULT '0' COMMENT '登录次数',
  `reg_ip` varchar(20) DEFAULT NULL COMMENT '注册IP',
  `reg_time` int(11) DEFAULT NULL COMMENT '注册时间',
  `last_login_ip` varchar(20) DEFAULT NULL COMMENT '最后登录IP',
  `last_login_time` int(11) DEFAULT NULL COMMENT '最后登录时间',
  `friend_num` int(11) NOT NULL DEFAULT '0' COMMENT '好友个数',
  `signature` varchar(255) DEFAULT NULL,
  `article_num` int(11) NOT NULL DEFAULT '0',
  `article_comments_num` int(11) NOT NULL DEFAULT '0',
  `article_views_num` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '用户状态 1为停止使用',
  `collect` tinyint(1) NOT NULL DEFAULT '0',
  `terminal` varchar(5) NOT NULL DEFAULT 'pc' COMMENT '用户终端',
  `ask_num` int(11) NOT NULL DEFAULT '0',
  `ask_answers_num` int(11) NOT NULL DEFAULT '0',
  `ask_views_num` int(11) NOT NULL DEFAULT '0',
  `post_num` int(11) NOT NULL DEFAULT '0',
  `post_comments_num` int(11) NOT NULL DEFAULT '0',
  `post_views_num` int(11) NOT NULL DEFAULT '0',
  `follow_num` int(11) NOT NULL DEFAULT '0',
  `fans_num` int(11) NOT NULL DEFAULT '0',
  `integral` int(11) NOT NULL DEFAULT '0',
  `home_page_views_num` int(11) NOT NULL DEFAULT '0',
  `money` decimal(11,2) DEFAULT '0.00',
  `avatar` varchar(255) DEFAULT NULL,
  `vip_start_time` int(11) DEFAULT NULL,
  `vip_end_time` int(11) DEFAULT NULL,
  `reference` varchar(255) DEFAULT '',
  `verify_email` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `username` (`username`),
  KEY `verify_email` (`verify_email`),
  KEY `group_id` (`group_id`),
  KEY `reg_time` (`reg_time`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_verify`;
CREATE TABLE `users_verify` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(36) NOT NULL DEFAULT '',
  `code` char(6) NOT NULL DEFAULT '',
  `token` char(36) NOT NULL DEFAULT '',
  `add_time` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_group`;
CREATE TABLE `users_group` (
  `group_id` smallint(3) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL DEFAULT '',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT 'icon小图标',
  `sort` int(11) NOT NULL DEFAULT '50',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  `remark` varchar(255) NOT NULL DEFAULT '',
  `isdelete` tinyint(1) NOT NULL DEFAULT '0',
  `create_time` int(11) NOT NULL DEFAULT '0',
  `update_time` int(11) NOT NULL DEFAULT '0',
  `type` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`group_id`),
  KEY `sort` (`sort`),
  KEY `group_id` (`group_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `users_group` VALUES ('1', '管理员', '', '1', '1', '', '0', '0', '0', 'admin'), ('2', '注册用户', '', '2', '1', '', '0', '0', '0', 'free');

DROP TABLE IF EXISTS `users_group_rel`;
CREATE TABLE `users_group_rel` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) DEFAULT '0',
  `group_pid` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `group_id` (`group_id`),
  KEY `group_pid` (`group_pid`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_group_extend`;
CREATE TABLE `users_group_extend` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) DEFAULT '0',
  `item_id` int(11) DEFAULT '0',
  `data` text ,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_favorite`;
CREATE TABLE `users_favorite` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uuid` char(32) NOT NULL,
  `uid` char(32) DEFAULT NULL,
  `item_id` char(32) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `item_id` (`item_id`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
 
DROP TABLE IF EXISTS `users_vote`;
CREATE TABLE `users_vote` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uuid` char(32) NOT NULL,
  `uid` char(32) DEFAULT NULL,
  `item_id` char(32) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `item_id` (`item_id`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_fans`;
CREATE TABLE `users_fans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid_from` char(32) DEFAULT NULL,
  `uid_to` char(32) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid_from` (`uid_from`),
  KEY `uid_to` (`uid_to`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `users_token`;
CREATE TABLE `users_token` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  `end_time` int(11) DEFAULT NULL,
  `terminal` varchar(10) NOT NULL DEFAULT '',
  `token` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `add_time` (`add_time`),
  KEY `end_time` (`end_time`),
  KEY `terminal` (`terminal`),
  KEY `token` (`token`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_nav`;
CREATE TABLE `widget_nav` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `target` tinyint(1) DEFAULT '0',
  `tempStatus` int(11) DEFAULT '0',
  `type` varchar(255) DEFAULT NULL,
  `sort` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `id` (`id`),
  KEY `sort` (`sort`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_contact`;
CREATE TABLE `widget_contact` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `tel` varchar(11) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_friend_link`;
CREATE TABLE `widget_friend_link` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `logo` varchar(255) DEFAULT NULL,
  `sort` int(5) DEFAULT '999',
  `type` varchar(100) DEFAULT 'all',
  `add_time` int(11) DEFAULT NULL,
  `status` int(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `name` (`name`),
  KEY `sort` (`sort`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_ad`;
CREATE TABLE `widget_ad` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  `add_time` int(11) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_pages`;
CREATE TABLE `widget_pages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url_name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  `site_id` char(32) CHARACTER SET latin1 DEFAULT NULL,
  `sort` int(11) DEFAULT NULL,
  `template` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `url_name` (`url_name`),
  KEY `sort` (`sort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `widget_mod`;
CREATE TABLE `widget_mod` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `author` varchar(255) DEFAULT NULL,
  `version` varchar(255) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  `status` int(11) DEFAULT NULL,
  `config` text,
  `is_admin` int(1) DEFAULT 0,
  `is_side` int(1) DEFAULT 0,
  `is_header` int(1) DEFAULT 0,
  `is_global` int(1) DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `is_global` (`is_global`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_cache`;
CREATE TABLE `articles_cache` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(255) NOT NULL,
  `add_time` int(11) DEFAULT NULL,
  `val` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `key` (`key`),
  KEY `add_time` (`add_time`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_setting`;
CREATE TABLE `articles_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `key` varchar(255) NOT NULL,
  `val` text,
  PRIMARY KEY (`id`),
  KEY `key` (`key`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_field`;
CREATE TABLE `articles_field` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `model_name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `field` varchar(255) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `style` varchar(255) DEFAULT NULL,
  `data` longtext,
  `sort` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `title` (`title`),
  KEY `model_name` (`model_name`),
  KEY `field` (`field`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_category`;
CREATE TABLE `articles_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `description` text,
  `pid` int(11) DEFAULT '0',
  `model_id` int(11) DEFAULT '0',
  `model_name` varchar(255) DEFAULT NULL,
  `sort` int(11) DEFAULT '99',
  `count_num` int(11) DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '1',
  `url_name` varchar(255) DEFAULT NULL,
  `is_page` int(11) NOT NULL DEFAULT '0',
  `mip_push_num` int(11) DEFAULT '0',
  `link_push_num` int(11) DEFAULT '0',
  `sm_push_num` int(11) DEFAULT '0',
  `xzh_realtime_push_num` int(11) DEFAULT '0',
  `xzh_batch_push_num` int(11) DEFAULT '0',
  `baidu_spider_num` int(11) DEFAULT '0',
  `baidu_spider_time` int(11) DEFAULT '0',
  `icon` varchar(255) DEFAULT NULL,
  `seo_title` varchar(255) DEFAULT NULL,
  `template` varchar(255) DEFAULT NULL,
  `category_url` varchar(255) DEFAULT NULL,
  `category_page_url` varchar(255) DEFAULT NULL,
  `detail_url` varchar(255) DEFAULT NULL,
  `detail_template` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  `url` varchar(255) DEFAULT NULL,
  `target` int(11) DEFAULT '0',
  `type` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `pid` (`pid`),
  KEY `title` (`title`),
  KEY `sort` (`sort`),
  KEY `status` (`status`),
  KEY `model_name` (`model_name`),
  KEY `type` (`type`),
  KEY `count_num` (`count_num`),
  KEY `url_name` (`url_name`),
  KEY `mip_push_num` (`mip_push_num`),
  KEY `link_push_num` (`link_push_num`),
  KEY `sm_push_num` (`sm_push_num`),
  KEY `xzh_realtime_push_num` (`xzh_realtime_push_num`),
  KEY `xzh_batch_push_num` (`xzh_batch_push_num`),
  KEY `baidu_spider_num` (`baidu_spider_num`),
  KEY `baidu_spider_time` (`baidu_spider_time`),
  KEY `is_page` (`is_page`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_search`;
CREATE TABLE `articles_search` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_search_rel`;
CREATE TABLE `articles_search_rel` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `search_id` int(11) DEFAULT '0',
  `item_id` int(11) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `search_id` (`search_id`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles`;
CREATE TABLE `articles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uuid` char(32) DEFAULT NULL,
  `cid` int(11) DEFAULT '0',
  `uid` char(32) DEFAULT NULL,
  `title` varchar(150) CHARACTER SET utf8mb4 DEFAULT NULL,
  `views` int(11) DEFAULT '0',
  `is_recommend` tinyint(1) DEFAULT '0',
  `is_about` int(1) DEFAULT '0',
  `is_chapter` int(1) DEFAULT '0',
  `is_img` int(1) DEFAULT '0',
  `mip_push_num` int(11) DEFAULT '0',
  `link_push_num` int(11) DEFAULT '0',
  `sm_push_num` int(11) DEFAULT '0',
  `xzh_realtime_push_num` int(11) DEFAULT '0',
  `xzh_batch_push_num` int(11) DEFAULT '0',
  `baidu_spider_num` int(11) DEFAULT '0',
  `baidu_spider_time` int(11) DEFAULT '0',
  `url_name` varchar(150) DEFAULT NULL,
  `category` varchar(255) DEFAULT NULL,
  `comments_num` int(11) DEFAULT '0',
  `description` text,
  `keywords` varchar(255) DEFAULT NULL,
  `create_time` int(11) DEFAULT '0',
  `edit_time` int(11) DEFAULT '0',
  `publish_time` int(11) DEFAULT '0',
  `img_url` varchar(255) DEFAULT NULL,
  `img_url_data` text,
  `collect_url` varchar(255) DEFAULT NULL,
  `elite` tinyint(1) DEFAULT '0',
  `top` tinyint(1) DEFAULT '0',
  `diy_brand` varchar(255) DEFAULT NULL,
  `diy_specs` varchar(255) DEFAULT NULL,
  `diy_place` varchar(255) DEFAULT NULL,
  `diy_down_url` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT '0.00',
  `daily_push_num` int(11) DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `id` (`id`),
  KEY `uuid` (`uuid`),
  KEY `title` (`title`),
  KEY `cid` (`cid`),
  KEY `is_recommend` (`is_recommend`),
  KEY `publish_time` (`publish_time`),
  KEY `category` (`category`),
  KEY `uid` (`uid`),
  KEY `views` (`views`),
  KEY `mip_push_num` (`mip_push_num`),
  KEY `link_push_num` (`link_push_num`),
  KEY `sm_push_num` (`sm_push_num`),
  KEY `xzh_realtime_push_num` (`xzh_realtime_push_num`),
  KEY `xzh_batch_push_num` (`xzh_batch_push_num`),
  KEY `baidu_spider_num` (`baidu_spider_num`),
  KEY `baidu_spider_time` (`baidu_spider_time`),
  KEY `daily_push_num` (`daily_push_num`),
  KEY `url_name` (`url_name`),
  KEY `elite` (`elite`),
  KEY `top` (`top`),
  KEY `comments_num` (`comments_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_comments`;
CREATE TABLE `articles_comments` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT null,
  `uid` char(32) DEFAULT null,
  `content` longtext CHARACTER SET utf8mb4,
  `item_id` char(32) DEFAULT null,
  `vote_count` int(11) NOT NULL DEFAULT '0',
  `favorite_count` int(11) NOT NULL DEFAULT '0',
  `is_answer` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否为最佳答案',
  `anonymous` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否匿名',
  `create_time` int(11) NOT NULL DEFAULT '0' COMMENT '回复时间',
  `is_check` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否审核',
  `comment_num` int(11) NOT NULL DEFAULT '0',
  `edit_time` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`auto_id`),
  KEY `auto_id` (`auto_id`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`),
  KEY `create_time` (`create_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
 

DROP TABLE IF EXISTS `articles_comments_comments`;
CREATE TABLE `articles_comments_comments` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT null,
  `item_id` char(32) DEFAULT null,
  `uid` char(32) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  `create_time` int(11) DEFAULT NULL,
  `edit_time` int(11) DEFAULT NULL,
  `is_reply` int(1) unsigned DEFAULT '0',
  `reply_uid` char(32) DEFAULT NULL,
  `reply_item_id` char(32) DEFAULT NULL,
  PRIMARY KEY (`auto_id`),
  KEY `auto_id` (`auto_id`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`),
  KEY `create_time` (`create_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_content`;
CREATE TABLE `articles_content` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`auto_id`),
  KEY `id` (`id`),
  KEY `auto_id` (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_pay_content`;
CREATE TABLE `articles_pay_content` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`auto_id`),
  KEY `id` (`id`),
  KEY `auto_id` (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tags`;
CREATE TABLE `tags` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `cid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(255) DEFAULT NULL, 
  `diy_title` varchar(255) DEFAULT NULL,
  `description` text,
  `keywords` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  `url_name` varchar(255) DEFAULT NULL,
  `relevance_num` int(11) DEFAULT NULL,
  `creator_uid` char(32) DEFAULT NULL,
  `add_time` int(11) DEFAULT NULL,
  `mip_push_num` int(11) DEFAULT '0',
  `link_push_num` int(11) DEFAULT '0',
  `sm_push_num` int(11) DEFAULT '0',
  `xzh_realtime_push_num` int(11) DEFAULT '0',
  `xzh_batch_push_num` int(11) DEFAULT '0',
  `baidu_spider_num` int(11) DEFAULT '0',
  `baidu_spider_time` int(11) DEFAULT '0',
  `daily_push_num` int(11) DEFAULT '0',
  PRIMARY KEY (`auto_id`),
  KEY `auto_id` (`auto_id`),
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `title` (`title`),
  KEY `url_name` (`url_name`),
  KEY `relevance_num` (`relevance_num`),
  KEY `mip_push_num` (`mip_push_num`),
  KEY `link_push_num` (`link_push_num`),
  KEY `sm_push_num` (`sm_push_num`),
  KEY `xzh_realtime_push_num` (`xzh_realtime_push_num`),
  KEY `xzh_batch_push_num` (`xzh_batch_push_num`),
  KEY `baidu_spider_num` (`baidu_spider_num`),
  KEY `baidu_spider_time` (`baidu_spider_time`),
  KEY `daily_push_num` (`daily_push_num`),
  KEY `add_time` (`add_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tags_category`;
CREATE TABLE `tags_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `description` text,
  `pid` int(11) DEFAULT '0',
  `sort` int(11) DEFAULT '99',
  `count_num` int(11) DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '1',
  `url_name` varchar(255) DEFAULT NULL,
  `is_page` int(11) NOT NULL DEFAULT '0',
  `mip_push_num` int(11) DEFAULT '0',
  `link_push_num` int(11) DEFAULT '0',
  `sm_push_num` int(11) DEFAULT '0',
  `icon` varchar(255) DEFAULT NULL,
  `seo_title` varchar(255) DEFAULT NULL,
  `template` varchar(255) DEFAULT NULL,
  `category_url` varchar(255) DEFAULT NULL,
  `category_page_url` varchar(255) DEFAULT NULL,
  `detail_url` varchar(255) DEFAULT NULL,
  `detail_template` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `pid` (`pid`),
  KEY `title` (`title`),
  KEY `sort` (`sort`),
  KEY `status` (`status`),
  KEY `count_num` (`count_num`),
  KEY `url_name` (`url_name`),
  KEY `mip_push_num` (`mip_push_num`),
  KEY `link_push_num` (`link_push_num`),
  KEY `sm_push_num` (`sm_push_num`),
  KEY `is_page` (`is_page`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tags_rel`;
CREATE TABLE `tags_rel` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` char(32) DEFAULT NULL,
  `tags_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`),
  KEY `item_type` (`item_type`),
  KEY `tags_id` (`tags_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `specials`;
CREATE TABLE `specials` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(150) CHARACTER SET utf8mb4 DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL,
  `description` text,
  `pid` int(11) DEFAULT '0',
  `sort` int(11) DEFAULT '99',
  `count_num` int(11) DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '1',
  `url_name` varchar(150) DEFAULT NULL,
  `is_page` int(11) NOT NULL DEFAULT '0',
  `mip_push_num` int(11) DEFAULT '0',
  `link_push_num` int(11) DEFAULT '0',
  `sm_push_num` int(11) DEFAULT '0',
  `icon` varchar(255) DEFAULT NULL,
  `seo_title` varchar(255) DEFAULT NULL,
  `template` varchar(255) DEFAULT NULL,
  `category_url` varchar(255) DEFAULT NULL,
  `category_page_url` varchar(255) DEFAULT NULL,
  `detail_url` varchar(255) DEFAULT NULL,
  `detail_template` varchar(255) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `pid` (`pid`),
  KEY `title` (`title`),
  KEY `sort` (`sort`),
  KEY `status` (`status`),
  KEY `count_num` (`count_num`),
  KEY `url_name` (`url_name`),
  KEY `mip_push_num` (`mip_push_num`),
  KEY `link_push_num` (`link_push_num`),
  KEY `sm_push_num` (`sm_push_num`),
  KEY `is_page` (`is_page`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8mb4;

DROP TABLE IF EXISTS `specials_rel`;
CREATE TABLE `specials_rel` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) DEFAULT NULL,
  `special_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`),
  KEY `special_id` (`special_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_model`;
CREATE TABLE `articles_model` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT INTO `articles_model` VALUES ('1', '文章', 'article'), ('2', '产品', 'product'), ('3', '下载', 'down'), ('4', '单页', 'page');

INSERT INTO `articles_field` VALUES ('1', 'product', '品牌','diy_brand','varchar','input','','1'), ('2', 'product', '规格','diy_specs','varchar','input','','2'),('3', 'product', '产地','diy_place','varchar','input','','3'),('4', 'down', '下载地址','diy_down_url','varchar','upload','','1');

DROP TABLE IF EXISTS `articles_verify`;
CREATE TABLE `articles_verify` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uuid` char(32) DEFAULT '',
  `cid` int(11) DEFAULT '0',
  `uid` char(32) DEFAULT '',
  `title` varchar(150) CHARACTER SET utf8mb4 DEFAULT '',
  `url_name` varchar(150) DEFAULT '',
  `img_url` varchar(255) DEFAULT '',
  `description` text,
  `keywords` varchar(255) DEFAULT '',
  `tags` varchar(255) DEFAULT '',
  `create_time` int(11) DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `content` longtext CHARACTER SET utf8mb4,
  `type` varchar(255) DEFAULT '',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `id` (`id`),
  KEY `uuid` (`uuid`),
  KEY `cid` (`cid`),
  KEY `uid` (`uid`),
  KEY `title` (`title`),
  KEY `status` (`status`),
  KEY `type` (`type`),
  KEY `create_time` (`create_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `articles_comments_verify`;
CREATE TABLE `articles_comments_verify` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT '',
  `uid` char(32) DEFAULT '',
  `pid` int(11) DEFAULT '0',
  `content` longtext CHARACTER SET utf8mb4,
  `item_id` char(32) DEFAULT '',
  `is_reply` int(11) DEFAULT '0',
  `reply_uid` char(32) DEFAULT '',
  `reply_item_id` char(32) DEFAULT '',
  `create_time` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`auto_id`),
  KEY `auto_id` (`auto_id`),
  KEY `id` (`id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`),
  KEY `status` (`status`),
  KEY `create_time` (`create_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_users_group_extend`;
CREATE TABLE `articles_users_group_extend` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) DEFAULT '0',
  `item_id` int(11) DEFAULT '0',
  `data` text ,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `articles_pay_content`;
CREATE TABLE `articles_pay_content` (
  `auto_id` int(11) NOT NULL AUTO_INCREMENT,
  `id` char(32) DEFAULT NULL,
  `content` longtext CHARACTER SET utf8mb4,
  PRIMARY KEY (`auto_id`),
  KEY `id` (`id`),
  KEY `auto_id` (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `pay_order_article_relation`;
CREATE TABLE `pay_order_article_relation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
	`uid` char(32) DEFAULT NULL,
  `order_id` char(32) DEFAULT NULL,
  `goods_id` char(32) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `buy_num` int(11) DEFAULT NULL,
  `pay_status` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `uid` (`uid`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `pay_log`;
CREATE TABLE `pay_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` char(32) DEFAULT NULL,
  `order_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  `sub_type` varchar(255) DEFAULT NULL,
  `item_name` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL COMMENT '总价',
  `add_time` int(11) DEFAULT NULL,
  `pay_type` varchar(255) DEFAULT NULL,
  `pay_money` decimal(11,2) DEFAULT '0.00' COMMENT '支付金额',
  `pay_time` int(11) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  `action` varchar(255) DEFAULT NULL,
  `receivables_uid` char(32) DEFAULT NULL,
  `receivables_money` decimal(11,2) DEFAULT '0.00',
  `transaction_type` varchar(255) DEFAULT NULL,
  `yue_before` decimal(11,2) DEFAULT NULL,
  `yue_after` decimal(11,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `item_type` (`item_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `pay_order`;
CREATE TABLE `pay_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` char(32) DEFAULT NULL,
  `uid` char(32) DEFAULT NULL,
  `mod_id` char(32) DEFAULT NULL,
  `item_id` char(32) DEFAULT NULL,
  `item_type` varchar(255) DEFAULT NULL,
  `sub_type` varchar(255) DEFAULT NULL,
  `item_name` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `money` decimal(11,2) DEFAULT NULL COMMENT '总价',
  `buy_num` int(11) DEFAULT NULL COMMENT '购买数量',
  `buy_money` decimal(11,2) DEFAULT NULL COMMENT '购买单价',
  `add_time` int(11) DEFAULT NULL,
  `pay_status` int(255) NOT NULL DEFAULT '0',
  `pay_type` varchar(255) DEFAULT NULL,
  `pay_money` decimal(11,2) DEFAULT '0.00' COMMENT '支付金额',
  `pay_time` int(11) DEFAULT NULL,
  `delivery_status` int(1) NOT NULL DEFAULT '0' COMMENT '发货状态',
  `delivery_time` int(11) DEFAULT NULL COMMENT '发货时间',
  `receiving_status` int(1) NOT NULL DEFAULT '0' COMMENT '收获状态',
  `receiving_time` int(11) DEFAULT NULL COMMENT '确认收货时间',
  `buyer_evaluation_status` int(1) NOT NULL DEFAULT '0' COMMENT '买家评价状态',
  `buyer_evaluation_time` int(11) DEFAULT NULL,
  `seller_evaluation_status` int(1) NOT NULL DEFAULT '0' COMMENT '卖家评价状态',
  `seller_evaluation_time` int(11) DEFAULT NULL,
  `is_close` int(1) NOT NULL DEFAULT '0',
  `is_close_time` int(11) DEFAULT NULL,
  `is_close_uid` char(32) DEFAULT NULL,
  `info` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `id` (`id`),
  KEY `order_id` (`order_id`),
  KEY `item_id` (`item_id`),
  KEY `uid` (`uid`),
  KEY `mod_id` (`mod_id`),
  KEY `item_type` (`item_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
