<?php
	define('DS', DIRECTORY_SEPARATOR);
	defined('HTML_PATH') or define('HTML_PATH', dirname(realpath(dirname(realpath($_SERVER['SCRIPT_FILENAME'])))) . DS);
    function fetch_dir($dir, $file_type = null) {
        $base_dir = realpath($dir);
        if (!file_exists($base_dir)) {
            return false;
        }
        $dir_handle = opendir($base_dir);
        $files_list = array();
        while (($file = readdir($dir_handle)) !== false) {
            if (substr($file, 0, 1) != '.' AND is_dir($base_dir . DS . $file)) {
                $files_list[] = $base_dir . DS . $file;
            }
        }
        closedir($dir_handle);
        return $files_list;
    }
    
    
    function fetch_file_lists($dir, $file_type = null) {
       if ($file_type) {
    	    if (substr($file_type, 0, 1) == '.') {
                $file_type = substr($file_type, 1);
            }
        }
    
        $base_dir = realpath($dir);
    
        if (!file_exists($base_dir)) {
            return false;
        }
    
        $dir_handle = opendir($base_dir);
    
        $files_list = array();
    
        while (($file = readdir($dir_handle)) !== false) {
            if (substr($file, 0, 1) != '.' AND !is_dir($base_dir . DS . $file)) {
                if (($file_type AND end(explode('.', $file)) == $file_type) OR !$file_type) {
                    $files_list[] = $base_dir . DS . $file;
                }
            }
            else if (substr($file, 0, 1) != '.' AND is_dir($base_dir . DS . $file)) {
                if ($sub_dir_lists = fetch_file_lists($base_dir . DS . $file, $file_type)) {
                    $files_list = array_merge($files_list, $sub_dir_lists);
                }
            }
        }
        closedir($dir_handle);
        return $files_list;
    }

	$tempComponent = '';
    $pages = [];
    $pageTemplatePath = HTML_PATH . 'html' . DS;
    $vueList = fetch_dir($pageTemplatePath);
    foreach ($vueList as $key => $file) {
        $tempArray = explode(DS, $file);
        $lastFileName = $tempArray[count($tempArray) - 1];
        if (preg_match('/^[a-zA-Z\s]+$/',$lastFileName)) {
            $vueFilePath = $file . DS . 'vue' . DS;
            $vueFilePathArray = fetch_file_lists($vueFilePath);
            if ($vueFilePathArray) {
                foreach ($vueFilePathArray as $k => $v) {
                    if (strpos($v, '.vue') !== false) {
                        $vueArray = explode(DS, $v);
                        array_push($pages,['pagePath' => $v,'pageName' => $vueArray[count($vueArray) - 1]]);
                    }
                }
            }
        }
    }
    if ($pages) {
        foreach ($pages as $key => $val) {
            $fileName = str_replace('.vue', '', $val['pageName']);
            $tempIndexData = file_get_contents($val['pagePath']);
            preg_match_all('/<script>([\w\W]*)<\/script>/iU', $tempIndexData, $scriptResult);
            if ($scriptResult) {
                $nameArray = explode('-', $fileName);
                $ucName = '';
                foreach ($nameArray as $k => $v) {
                    $ucName .= ucfirst($v);
                }
                preg_match_all('/<template>(.*?)<\/template>/is', $tempIndexData, $templateResult);
                $tempComponent .= "const ".$ucName." = {";
                $tempComponent .= "template: `".$templateResult[1][0]."`,";
                $scriptResult[1][0] = str_replace('export default {', '', $scriptResult[1][0]);
                $tempComponent .= $scriptResult[1][0];
                $tempComponent .= "Vue.component('".$fileName."',".$ucName.");";
                $tempComponent .= "Vue.component('".$ucName."',".$ucName.");";
                $tempIndexData = '';
                $scriptResult = '';
                $templateResult = '';
            } 
        }
    }
    $tempComponent = preg_replace( '/ {2,}/', '',$tempComponent);
    
    header('Content-Type: application/x-javascript; charset=UTF-8');
    echo $tempComponent;
